#import "enunciate-common.h"

@class NEXUS_SMARTPROXY_PLUGINNS0Settings;
@class NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe;
@class NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse;
@class NEXUS_SMARTPROXY_PLUGINNS0NexusResponse;
@class NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest;
@class NEXUS_SMARTPROXY_PLUGINNS0Certificate;
@class NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope;
@class NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope;
@class NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope;
@class NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope;
@class NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope;
@class NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse;
@class NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest;
@class NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse;
@class NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest;
@class NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope;
@class NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope;

#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0Settings_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0Settings_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0Settings : NSObject
{
  @private
    BOOL *_enabled;
    NSString *_advertiseUri;
    NEXUS_SMARTPROXY_PLUGINNS0Certificate *_identity;
    int _port;
    NSString *_host;
}

/**
 * (no documentation provided)
 */
- (BOOL *) enabled;

/**
 * (no documentation provided)
 */
- (void) setEnabled: (BOOL *) newEnabled;

/**
 * (no documentation provided)
 */
- (NSString *) advertiseUri;

/**
 * (no documentation provided)
 */
- (void) setAdvertiseUri: (NSString *) newAdvertiseUri;

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) identity;

/**
 * (no documentation provided)
 */
- (void) setIdentity: (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) newIdentity;

/**
 * (no documentation provided)
 */
- (int) port;

/**
 * (no documentation provided)
 */
- (void) setPort: (int) newPort;

/**
 * (no documentation provided)
 */
- (NSString *) host;

/**
 * (no documentation provided)
 */
- (void) setHost: (NSString *) newHost;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0Settings */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0Settings_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe : NSObject
{
  @private
    BOOL _subscribe;
    NSString *_repositoryId;
    BOOL _publish;
    BOOL _preemptiveFetch;
}

/**
 * (no documentation provided)
 */
- (BOOL) subscribe;

/**
 * (no documentation provided)
 */
- (void) setSubscribe: (BOOL) newSubscribe;

/**
 * (no documentation provided)
 */
- (NSString *) repositoryId;

/**
 * (no documentation provided)
 */
- (void) setRepositoryId: (NSString *) newRepositoryId;

/**
 * (no documentation provided)
 */
- (BOOL) publish;

/**
 * (no documentation provided)
 */
- (void) setPublish: (BOOL) newPublish;

/**
 * (no documentation provided)
 */
- (BOOL) preemptiveFetch;

/**
 * (no documentation provided)
 */
- (void) setPreemptiveFetch: (BOOL) newPreemptiveFetch;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse : NSObject
{
  @private
    NSString *_description;
    NEXUS_SMARTPROXY_PLUGINNS0Certificate *_certificate;
    NSString *_identifier;
}

/**
 * (no documentation provided)
 */
- (NSString *) description;

/**
 * (no documentation provided)
 */
- (void) setDescription: (NSString *) newDescription;

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) certificate;

/**
 * (no documentation provided)
 */
- (void) setCertificate: (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) newCertificate;

/**
 * (no documentation provided)
 */
- (NSString *) identifier;

/**
 * (no documentation provided)
 */
- (void) setIdentifier: (NSString *) newIdentifier;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0NexusResponse_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0NexusResponse_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0NexusResponse : NSObject
{
  @private
}
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0NexusResponse */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0NexusResponse_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest : NSObject
{
  @private
    NSString *_identifier;
    NSString *_certificate;
    NSString *_description;
}

/**
 * (no documentation provided)
 */
- (NSString *) identifier;

/**
 * (no documentation provided)
 */
- (void) setIdentifier: (NSString *) newIdentifier;

/**
 * (no documentation provided)
 */
- (NSString *) certificate;

/**
 * (no documentation provided)
 */
- (void) setCertificate: (NSString *) newCertificate;

/**
 * (no documentation provided)
 */
- (NSString *) description;

/**
 * (no documentation provided)
 */
- (void) setDescription: (NSString *) newDescription;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0Certificate_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0Certificate_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0Certificate : NSObject
{
  @private
    NSString *_fingerprint;
    NSString *_detail;
    NSString *_pem;
}

/**
 * (no documentation provided)
 */
- (NSString *) fingerprint;

/**
 * (no documentation provided)
 */
- (void) setFingerprint: (NSString *) newFingerprint;

/**
 * (no documentation provided)
 */
- (NSString *) detail;

/**
 * (no documentation provided)
 */
- (void) setDetail: (NSString *) newDetail;

/**
 * (no documentation provided)
 */
- (NSString *) pem;

/**
 * (no documentation provided)
 */
- (void) setPem: (NSString *) newPem;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0Certificate */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0Certificate_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope : NEXUS_SMARTPROXY_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest *_data;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest *) newData;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope : NEXUS_SMARTPROXY_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse *_data;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse *) newData;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope : NEXUS_SMARTPROXY_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * (no documentation provided)
 */
- (NSArray *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NSArray *) newData;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope : NEXUS_SMARTPROXY_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest *_data;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest *) newData;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope : NEXUS_SMARTPROXY_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse *_data;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse *) newData;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse : NEXUS_SMARTPROXY_PLUGINNS0Settings
{
  @private
    NSString *_status;
}

/**
 * (no documentation provided)
 */
- (NSString *) status;

/**
 * (no documentation provided)
 */
- (void) setStatus: (NSString *) newStatus;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest : NEXUS_SMARTPROXY_PLUGINNS0Settings
{
  @private
    NSArray *_trustedKeys;
}

/**
 * (no documentation provided)
 */
- (NSArray *) trustedKeys;

/**
 * (no documentation provided)
 */
- (void) setTrustedKeys: (NSArray *) newTrustedKeys;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse : NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe
{
  @private
    NEXUS_SMARTPROXY_PLUGINNS0Certificate *_certificate;
    NSString *_subscriptionStatus;
    NSString *_publishStatus;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) certificate;

/**
 * (no documentation provided)
 */
- (void) setCertificate: (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) newCertificate;

/**
 * (no documentation provided)
 */
- (NSString *) subscriptionStatus;

/**
 * (no documentation provided)
 */
- (void) setSubscriptionStatus: (NSString *) newSubscriptionStatus;

/**
 * (no documentation provided)
 */
- (NSString *) publishStatus;

/**
 * (no documentation provided)
 */
- (void) setPublishStatus: (NSString *) newPublishStatus;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest : NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe
{
  @private
}
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope : NEXUS_SMARTPROXY_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse *_data;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse *) newData;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope_H */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope_H
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope_H

/**
 * (no documentation provided)
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope : NEXUS_SMARTPROXY_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest *_data;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest *) newData;
@end /* interface NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope_H */
