#import "nexus-usertoken-plugin.h"
#ifndef DEF_NEXUS_USERTOKEN_PLUGINAPIStatusXO_M
#define DEF_NEXUS_USERTOKEN_PLUGINAPIStatusXO_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_USERTOKEN_PLUGINAPIStatusXO

/**
 * (no documentation provided)
 */
- (BOOL) enabled
{
  return _enabled;
}

/**
 * (no documentation provided)
 */
- (void) setEnabled: (BOOL) newEnabled
{
  _enabled = newEnabled;
}

- (void) dealloc
{
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_USERTOKEN_PLUGINAPIStatusXO *_nEXUS_USERTOKEN_PLUGINAPIStatusXO;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_USERTOKEN_PLUGINAPIStatusXO = (NEXUS_USERTOKEN_PLUGINAPIStatusXO *) [NEXUS_USERTOKEN_PLUGINAPIStatusXO readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_USERTOKEN_PLUGINAPIStatusXO;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPIStatusXO */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_USERTOKEN_PLUGINAPIStatusXO (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_USERTOKEN_PLUGINAPIStatusXO (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_USERTOKEN_PLUGINAPIStatusXO (JAXB)

/**
 * Read an instance of NEXUS_USERTOKEN_PLUGINAPIStatusXO from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_USERTOKEN_PLUGINAPIStatusXO defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_USERTOKEN_PLUGINAPIStatusXO *_nEXUS_USERTOKEN_PLUGINAPIStatusXO = [[NEXUS_USERTOKEN_PLUGINAPIStatusXO alloc] init];
  NS_DURING
  {
    [_nEXUS_USERTOKEN_PLUGINAPIStatusXO initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_USERTOKEN_PLUGINAPIStatusXO = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_USERTOKEN_PLUGINAPIStatusXO autorelease];
  return _nEXUS_USERTOKEN_PLUGINAPIStatusXO;
}

/**
 * Initialize this instance of NEXUS_USERTOKEN_PLUGINAPIStatusXO according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_USERTOKEN_PLUGINAPIStatusXO to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_USERTOKEN_PLUGINAPIStatusXO from an XML reader. The element to be read is
 * "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status".
 *
 * @param reader The XML reader.
 * @return The NEXUS_USERTOKEN_PLUGINAPIStatusXO.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_USERTOKEN_PLUGINAPIStatusXO *_statusXO = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status."];
    }
  }

  if (xmlStrcmp(BAD_CAST "status", xmlTextReaderConstLocalName(reader)) == 0
      && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status.");
#endif
    _statusXO = (NEXUS_USERTOKEN_PLUGINAPIStatusXO *)[NEXUS_USERTOKEN_PLUGINAPIStatusXO readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPIStatusXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPIStatusXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _statusXO;
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPIStatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPIStatusXO to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "status", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status. XML writer status: %i\n", rc];
  }

  if (writeNs) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status...");
#endif

    rc = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (rc < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing attribute 'xmlns:api' on '{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status'. XML writer status: %i\n", rc];
    }
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status...");
#endif
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setEnabled: *((BOOL*) _child_accessor)];
    free(_child_accessor);
    return YES;
  }

  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if (YES) { //always write the primitive element...
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}enabled."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}enabled...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, &_enabled);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}enabled...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}enabled."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}enabled."];
    }
  }
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPIStatusXO (JAXB) */

#endif /* DEF_NEXUS_USERTOKEN_PLUGINAPIStatusXO_M */
#ifndef DEF_NEXUS_USERTOKEN_PLUGINAPIUserTokenXO_M
#define DEF_NEXUS_USERTOKEN_PLUGINAPIUserTokenXO_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_USERTOKEN_PLUGINAPIUserTokenXO

/**
 * (no documentation provided)
 */
- (NSString *) nameCode
{
  return _nameCode;
}

/**
 * (no documentation provided)
 */
- (void) setNameCode: (NSString *) newNameCode
{
  [newNameCode retain];
  [_nameCode release];
  _nameCode = newNameCode;
}

/**
 * (no documentation provided)
 */
- (NSString *) passCode
{
  return _passCode;
}

/**
 * (no documentation provided)
 */
- (void) setPassCode: (NSString *) newPassCode
{
  [newPassCode retain];
  [_passCode release];
  _passCode = newPassCode;
}

/**
 * (no documentation provided)
 */
- (NSString *) created
{
  return _created;
}

/**
 * (no documentation provided)
 */
- (void) setCreated: (NSString *) newCreated
{
  [newCreated retain];
  [_created release];
  _created = newCreated;
}

- (void) dealloc
{
  [self setNameCode: nil];
  [self setPassCode: nil];
  [self setCreated: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_USERTOKEN_PLUGINAPIUserTokenXO *_nEXUS_USERTOKEN_PLUGINAPIUserTokenXO;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_USERTOKEN_PLUGINAPIUserTokenXO = (NEXUS_USERTOKEN_PLUGINAPIUserTokenXO *) [NEXUS_USERTOKEN_PLUGINAPIUserTokenXO readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_USERTOKEN_PLUGINAPIUserTokenXO;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPIUserTokenXO */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_USERTOKEN_PLUGINAPIUserTokenXO (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_USERTOKEN_PLUGINAPIUserTokenXO (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_USERTOKEN_PLUGINAPIUserTokenXO (JAXB)

/**
 * Read an instance of NEXUS_USERTOKEN_PLUGINAPIUserTokenXO from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_USERTOKEN_PLUGINAPIUserTokenXO defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_USERTOKEN_PLUGINAPIUserTokenXO *_nEXUS_USERTOKEN_PLUGINAPIUserTokenXO = [[NEXUS_USERTOKEN_PLUGINAPIUserTokenXO alloc] init];
  NS_DURING
  {
    [_nEXUS_USERTOKEN_PLUGINAPIUserTokenXO initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_USERTOKEN_PLUGINAPIUserTokenXO = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_USERTOKEN_PLUGINAPIUserTokenXO autorelease];
  return _nEXUS_USERTOKEN_PLUGINAPIUserTokenXO;
}

/**
 * Initialize this instance of NEXUS_USERTOKEN_PLUGINAPIUserTokenXO according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_USERTOKEN_PLUGINAPIUserTokenXO to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_USERTOKEN_PLUGINAPIUserTokenXO from an XML reader. The element to be read is
 * "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken".
 *
 * @param reader The XML reader.
 * @return The NEXUS_USERTOKEN_PLUGINAPIUserTokenXO.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_USERTOKEN_PLUGINAPIUserTokenXO *_userTokenXO = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken."];
    }
  }

  if (xmlStrcmp(BAD_CAST "userToken", xmlTextReaderConstLocalName(reader)) == 0
      && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken.");
#endif
    _userTokenXO = (NEXUS_USERTOKEN_PLUGINAPIUserTokenXO *)[NEXUS_USERTOKEN_PLUGINAPIUserTokenXO readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPIUserTokenXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPIUserTokenXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _userTokenXO;
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPIUserTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPIUserTokenXO to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "userToken", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken. XML writer status: %i\n", rc];
  }

  if (writeNs) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken...");
#endif

    rc = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (rc < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing attribute 'xmlns:api' on '{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken'. XML writer status: %i\n", rc];
    }
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken...");
#endif
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "nameCode", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}nameCode of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}nameCode of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setNameCode: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "passCode", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}passCode of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}passCode of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setPassCode: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "created", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}created of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}created of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setCreated: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self nameCode]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "nameCode", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}nameCode."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}nameCode...");
#endif
    [[self nameCode] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}nameCode...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}nameCode."];
    }
  }
  if ([self passCode]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "passCode", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}passCode."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}passCode...");
#endif
    [[self passCode] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}passCode...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}passCode."];
    }
  }
  if ([self created]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "created", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}created."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}created...");
#endif
    [[self created] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}created...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}created."];
    }
  }
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPIUserTokenXO (JAXB) */

#endif /* DEF_NEXUS_USERTOKEN_PLUGINAPIUserTokenXO_M */
#ifndef DEF_NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO_M
#define DEF_NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO

/**
 * (no documentation provided)
 */
- (BOOL) provisioned
{
  return _provisioned;
}

/**
 * (no documentation provided)
 */
- (void) setProvisioned: (BOOL) newProvisioned
{
  _provisioned = newProvisioned;
}

/**
 * (no documentation provided)
 */
- (NSString *) created
{
  return _created;
}

/**
 * (no documentation provided)
 */
- (void) setCreated: (NSString *) newCreated
{
  [newCreated retain];
  [_created release];
  _created = newCreated;
}

- (void) dealloc
{
  [self setCreated: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO *_nEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO = (NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO *) [NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO (JAXB)

/**
 * Read an instance of NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO *_nEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO = [[NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO alloc] init];
  NS_DURING
  {
    [_nEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO autorelease];
  return _nEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO;
}

/**
 * Initialize this instance of NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO from an XML reader. The element to be read is
 * "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus".
 *
 * @param reader The XML reader.
 * @return The NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO *_userTokenStatusXO = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus."];
    }
  }

  if (xmlStrcmp(BAD_CAST "userTokenStatus", xmlTextReaderConstLocalName(reader)) == 0
      && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus.");
#endif
    _userTokenStatusXO = (NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO *)[NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _userTokenStatusXO;
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "userTokenStatus", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus. XML writer status: %i\n", rc];
  }

  if (writeNs) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus...");
#endif

    rc = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (rc < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing attribute 'xmlns:api' on '{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus'. XML writer status: %i\n", rc];
    }
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus...");
#endif
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "provisioned", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setProvisioned: *((BOOL*) _child_accessor)];
    free(_child_accessor);
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "created", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    status = 1;
    if (xmlTextReaderMoveToAttributeNs(reader, BAD_CAST "nil", BAD_CAST "http://www.w3.org/2001/XMLSchema-instance")) {
      if (xmlStrcmp(BAD_CAST "true", xmlTextReaderConstValue(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
        NSLog(@"Choice {}created was nil according to the xsi:nil attribute.");
#endif
        __child = nil;
        status = 0;
      }
    }

    xmlTextReaderMoveToElement(reader); //move back to the element
    if (status) { //if not "nil"...
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}created of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}created of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    } //end "if not nil" clause
    else if (xmlTextReaderIsEmptyElement(reader) == 0) {
      //if it's not the empty element, skip it because it's nil.
      xmlTextReaderSkipElement(reader);
    }

    [self setCreated: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if (YES) { //always write the primitive element...
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "provisioned", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}provisioned."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}provisioned...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, &_provisioned);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}provisioned...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}provisioned."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}provisioned."];
    }
  }
  if ([self created]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "created", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}created."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}created...");
#endif
    [[self created] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}created...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}created."];
    }
  }
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO (JAXB) */

#endif /* DEF_NEXUS_USERTOKEN_PLUGINAPIUserTokenStatusXO_M */
#ifndef DEF_NEXUS_USERTOKEN_PLUGINAPISettingsXO_M
#define DEF_NEXUS_USERTOKEN_PLUGINAPISettingsXO_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_USERTOKEN_PLUGINAPISettingsXO

/**
 * (no documentation provided)
 */
- (BOOL) enabled
{
  return _enabled;
}

/**
 * (no documentation provided)
 */
- (void) setEnabled: (BOOL) newEnabled
{
  _enabled = newEnabled;
}

/**
 * (no documentation provided)
 */
- (BOOL) protectContent
{
  return _protectContent;
}

/**
 * (no documentation provided)
 */
- (void) setProtectContent: (BOOL) newProtectContent
{
  _protectContent = newProtectContent;
}

/**
 * (no documentation provided)
 */
- (BOOL *) realmConfigured
{
  return _realmConfigured;
}

/**
 * (no documentation provided)
 */
- (void) setRealmConfigured: (BOOL *) newRealmConfigured
{
  if (_realmConfigured != NULL) {
    free(_realmConfigured);
  }
  _realmConfigured = newRealmConfigured;
}

- (void) dealloc
{
  [self setRealmConfigured: NULL];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_USERTOKEN_PLUGINAPISettingsXO *_nEXUS_USERTOKEN_PLUGINAPISettingsXO;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_USERTOKEN_PLUGINAPISettingsXO = (NEXUS_USERTOKEN_PLUGINAPISettingsXO *) [NEXUS_USERTOKEN_PLUGINAPISettingsXO readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_USERTOKEN_PLUGINAPISettingsXO;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPISettingsXO */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_USERTOKEN_PLUGINAPISettingsXO (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_USERTOKEN_PLUGINAPISettingsXO (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_USERTOKEN_PLUGINAPISettingsXO (JAXB)

/**
 * Read an instance of NEXUS_USERTOKEN_PLUGINAPISettingsXO from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_USERTOKEN_PLUGINAPISettingsXO defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_USERTOKEN_PLUGINAPISettingsXO *_nEXUS_USERTOKEN_PLUGINAPISettingsXO = [[NEXUS_USERTOKEN_PLUGINAPISettingsXO alloc] init];
  NS_DURING
  {
    [_nEXUS_USERTOKEN_PLUGINAPISettingsXO initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_USERTOKEN_PLUGINAPISettingsXO = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_USERTOKEN_PLUGINAPISettingsXO autorelease];
  return _nEXUS_USERTOKEN_PLUGINAPISettingsXO;
}

/**
 * Initialize this instance of NEXUS_USERTOKEN_PLUGINAPISettingsXO according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_USERTOKEN_PLUGINAPISettingsXO to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_USERTOKEN_PLUGINAPISettingsXO from an XML reader. The element to be read is
 * "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings".
 *
 * @param reader The XML reader.
 * @return The NEXUS_USERTOKEN_PLUGINAPISettingsXO.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_USERTOKEN_PLUGINAPISettingsXO *_settingsXO = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings."];
    }
  }

  if (xmlStrcmp(BAD_CAST "settings", xmlTextReaderConstLocalName(reader)) == 0
      && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings.");
#endif
    _settingsXO = (NEXUS_USERTOKEN_PLUGINAPISettingsXO *)[NEXUS_USERTOKEN_PLUGINAPISettingsXO readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPISettingsXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPISettingsXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _settingsXO;
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPISettingsXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPISettingsXO to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "settings", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings. XML writer status: %i\n", rc];
  }

  if (writeNs) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings...");
#endif

    rc = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (rc < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing attribute 'xmlns:api' on '{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings'. XML writer status: %i\n", rc];
    }
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings...");
#endif
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setEnabled: *((BOOL*) _child_accessor)];
    free(_child_accessor);
    return YES;
  }

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "protectContent", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setProtectContent: *((BOOL*) _child_accessor)];
    free(_child_accessor);
    return YES;
  }

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "realmConfigured", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setRealmConfigured: ((BOOL*) _child_accessor)];
    return YES;
  }

  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if (YES) { //always write the primitive element...
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}enabled."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}enabled...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, &_enabled);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}enabled...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}enabled."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}enabled."];
    }
  }
  if (YES) { //always write the primitive element...
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "protectContent", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}protectContent."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}protectContent...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, &_protectContent);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}protectContent...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}protectContent."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}protectContent."];
    }
  }
  if ([self realmConfigured] != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "realmConfigured", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}realmConfigured."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}realmConfigured...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, [self realmConfigured]);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}realmConfigured...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}realmConfigured."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}realmConfigured."];
    }
  }
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPISettingsXO (JAXB) */

#endif /* DEF_NEXUS_USERTOKEN_PLUGINAPISettingsXO_M */
#ifndef DEF_NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO_M
#define DEF_NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO

/**
 * (no documentation provided)
 */
- (NSString *) u
{
  return _u;
}

/**
 * (no documentation provided)
 */
- (void) setU: (NSString *) newU
{
  [newU retain];
  [_u release];
  _u = newU;
}

/**
 * (no documentation provided)
 */
- (NSString *) p
{
  return _p;
}

/**
 * (no documentation provided)
 */
- (void) setP: (NSString *) newP
{
  [newP retain];
  [_p release];
  _p = newP;
}

- (void) dealloc
{
  [self setU: nil];
  [self setP: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO *_nEXUS_USERTOKEN_PLUGINAPIAuthTokenXO;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_USERTOKEN_PLUGINAPIAuthTokenXO = (NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO *) [NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_USERTOKEN_PLUGINAPIAuthTokenXO;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO (JAXB)

/**
 * Read an instance of NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO *_nEXUS_USERTOKEN_PLUGINAPIAuthTokenXO = [[NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO alloc] init];
  NS_DURING
  {
    [_nEXUS_USERTOKEN_PLUGINAPIAuthTokenXO initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_USERTOKEN_PLUGINAPIAuthTokenXO = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_USERTOKEN_PLUGINAPIAuthTokenXO autorelease];
  return _nEXUS_USERTOKEN_PLUGINAPIAuthTokenXO;
}

/**
 * Initialize this instance of NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO from an XML reader. The element to be read is
 * "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken".
 *
 * @param reader The XML reader.
 * @return The NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO *_authTokenXO = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken."];
    }
  }

  if (xmlStrcmp(BAD_CAST "authToken", xmlTextReaderConstLocalName(reader)) == 0
      && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken.");
#endif
    _authTokenXO = (NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO *)[NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO. Expected element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _authTokenXO;
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "authToken", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken. XML writer status: %i\n", rc];
  }

  if (writeNs) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken...");
#endif

    rc = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (rc < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing attribute 'xmlns:api' on '{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken'. XML writer status: %i\n", rc];
    }
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken...");
#endif
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "u", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}u of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}u of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setU: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "p", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}p of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}p of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setP: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self u]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "u", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}u."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}u...");
#endif
    [[self u] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}u...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}u."];
    }
  }
  if ([self p]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "p", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}p."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}p...");
#endif
    [[self p] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}p...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}p."];
    }
  }
}
@end /* implementation NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO (JAXB) */

#endif /* DEF_NEXUS_USERTOKEN_PLUGINAPIAuthTokenXO_M */
