Ext.namespace("Nexus.staging");
(function(){var Trait=function(methods){this.treat=function(obj){if(obj.prototype){obj=obj.prototype
}Ext.apply(obj,methods)
}
};
Nexus.staging.Rules=new Trait({generateHtmlFromRulesetFailure:function(responseText){var json=Ext.decode(responseText),html="<p><h3>Staging ruleset evaluation on repository '"+json.repositoryName+"' has failed.</h3>";
Ext.each(json.failures,function(item){html+="<br/><p><h3>"+item.ruleName+"</h3></p>";
Ext.each(item.messages,function(msg){html+="&nbsp;&nbsp;&nbsp;&nbsp;-"+msg+"<br/>"
})
});
html+="</p>";
return html
},showRulesetEvaluationReport:function(responseText){var reportWindow=new Ext.Window({id:"ruleset-evaluation-report",title:"Ruleset Evaluation Report",layout:"border",width:600,height:300,buttonAlign:"center",items:[{xtype:"panel",autoScroll:true,html:this.generateHtmlFromRulesetFailure(responseText),region:"center"}],buttons:[{text:"OK",scope:this,handler:function(){Ext.getCmp("ruleset-evaluation-report").close()
}}]});
reportWindow.show()
}})
})();
Sonatype.repoServer.StagingPanel=function(cfg){var i,sp=Sonatype.lib.Permissions,toolbar=[],updateGridView,_this=this,config=cfg||{},defaultConfig={title:"Staging Profiles"};
Ext.apply(this,config,defaultConfig);
this.targetStore=new Ext.data.JsonStore({root:"data",id:"resourceURI",fields:[{name:"id"},{name:"name",sortType:Ext.data.SortTypes.asUCString},{name:"contentClass"}],sortInfo:{field:"name",direction:"ASC"},url:Sonatype.config.repos.urls.repoTargets,autoLoad:false,listeners:{load:{fn:function(store,recs,opts){for(i=recs.length-1;
i>=0;
i--){var rec=recs[i];
if(rec.get("contentClass")!="maven1"&&rec.get("contentClass")!="maven2"){store.remove(rec)
}}},scope:this}}});
this.groupStore=new Ext.data.JsonStore({root:"data",id:"id",fields:[{name:"resourceURI"},{name:"id"},{name:"name",sortType:Ext.data.SortTypes.asUCString},{name:"format"},{name:"userManaged"}],sortInfo:{field:"name",direction:"ASC"},url:Sonatype.config.repos.urls.groups,autoLoad:false,listeners:{load:{fn:function(store,recs,opts){for(var i=recs.length-1;
i>=0;
i--){var rec=recs[i];
if(!rec.get("userManaged")){store.remove(rec)
}}},scope:this}}});
this.repoStore=new Ext.data.JsonStore({root:"data",id:"id",fields:[{name:"resourceURI"},{name:"id"},{name:"name",sortType:Ext.data.SortTypes.asUCString},{name:"format"},{name:"repoType"},{name:"repoPolicy"}],sortInfo:{field:"name",direction:"ASC"},url:Sonatype.config.repos.urls.repositories,autoLoad:false});
this.modeStore=new Ext.data.SimpleStore({fields:["value","display"],data:[["BOTH","Deploy and UI Upload"],["DEPLOY","Deploy"],["UPLOAD","UI Upload"]]});
this.fullModeStore=new Ext.data.SimpleStore({fields:["value","display"],data:[["BOTH","Deploy and UI Upload"],["DEPLOY","Deploy"],["UPLOAD","UI Upload"],["GROUP","Group"]]});
this.joinGroups=function(value,parent){var s="";
for(var i=0;
i<value.length;
i++){if(i>0){s+=", "
}if(value[i]){var rec=this.groupStore.getAt(this.groupStore.find("id",value[i]));
if(rec){s+=rec.get("name")
}}}return s
};
this.getRepositoryTarget=function(val,parent){if(val){var rec=this.targetStore.getAt(this.targetStore.find("id",val));
if(rec){return rec.get("name")
}}return""
};
this.getRepoName=function(value,parent){if(value){var rec=this.repoStore.getAt(this.repoStore.find("id",new RegExp("^"+value+"$")));
if(rec){return rec.get("name")
}}return""
};
this.getModeName=function(value,parent){if(value){var rec=this.fullModeStore.getAt(this.fullModeStore.find("value",value));
if(rec){return rec.get("display")
}}return""
};
if(sp.checkPermission("nexus:stagingprofileorder",sp.CREATE)){toolbar.push({id:"profile-move-up-button",text:"Move Up",icon:Sonatype.config.resourcePath+"/images/icons/move-up.gif",cls:"x-btn-text-icon",tooltip:{title:"Profile Ordering",text:"Move the profile up in the list priority."},handler:this.moveUpResourceHandler,scope:this},{id:"profile-move-down-button",text:"Move Down",icon:Sonatype.config.resourcePath+"/images/icons/move-down.gif",cls:"x-btn-text-icon",tooltip:{title:"Profile Ordering",text:"Move the profile down in the list priority."},handler:this.moveDownResourceHandler,scope:this},{id:"profile-save-order-button",text:"Save Order",icon:Sonatype.config.extPath+"/resources/images/default/dd/drop-yes.gif",cls:"x-btn-text-icon",tooltip:{title:"Profile Ordering",text:"Save the current profile priority order."},handler:this.saveOrderResourceHandler,scope:this})
}var mask;
var latch=0;
var dataStoreLoader=function(){latch=latch+1;
if(latch>=_this.dataStores.length){_this.dataStore.load()
}};
var dataStores=[this.targetStore,this.groupStore,this.repoStore];
for(var j=0;
j<dataStores.length;
j++){var store=dataStores[j];
store.on("load",dataStoreLoader,_this,{single:true})
}Sonatype.repoServer.StagingPanel.superclass.constructor.call(this,{dataStores:dataStores,addMenuInitEvent:"profileAddMenuInit",deleteButton:sp.checkPermission("nexus:stagingprofiles",sp.DELETE),rowClickEvent:"profileViewInit",url:Sonatype.config.servicePath+"/staging/profiles",dataAutoLoad:false,tabbedChildren:true,tbar:toolbar,dataSortInfo:{field:"order",direction:"asc"},columns:[{name:"resourceURI"},{name:"id"},{name:"name",header:"Name",width:100,renderer:function(value,metadata,record,rowIndex,colIndex,store){return record.get("mode")=="GROUP"?("<b>"+value+"</b>"):value
}},{name:"mode"},{name:"sMode",header:"Mode",width:150,mapping:"mode",convert:this.getModeName.createDelegate(this)},{name:"repositoryTargetId"},{name:"sTarget",header:"Repo Target",width:100,mapping:"repositoryTargetId",convert:this.getRepositoryTarget.createDelegate(this)},{name:"currentRepositoryIds"},{name:"inProgress"},{name:"order",sortType:Ext.data.SortTypes.asInt},{name:"finishNotifyRoles"},{name:"promotionNotifyRoles"},{name:"promotionTargetRepository"},{name:"deployURI"},{name:"sPromotionTargetRepository",header:"Release Repository",width:200,mapping:"promotionTargetRepository",convert:this.getRepoName.createDelegate(this)},{name:"targetGroups"},{name:"sTargetGroups",header:"Target Groups",width:150,mapping:"targetGroups",convert:this.joinGroups.createDelegate(this),autoExpand:true}]});
this.gridPanel.on("render",function(){if(!this.dataStore.isLoaded){mask=new Ext.LoadMask(_this.gridPanel.el);
mask.show()
}},_this,{single:true,delay:100});
this.dataStore.on("load",function(){if(mask){mask.hide()
}})
};
Ext.extend(Sonatype.repoServer.StagingPanel,Sonatype.panels.GridViewer,{moveUpResourceHandler:function(){if(this.gridPanel.getSelectionModel().hasSelection()){var rec=this.gridPanel.getSelectionModel().getSelected();
if(rec){var i=this.gridPanel.getStore().indexOf(rec);
if(i>0){this.gridPanel.getStore().remove(rec);
this.gridPanel.getStore().insert(i-1,rec);
this.gridPanel.getSelectionModel().selectRecords([rec],false)
}}}},moveDownResourceHandler:function(){if(this.gridPanel.getSelectionModel().hasSelection()){var rec=this.gridPanel.getSelectionModel().getSelected();
if(rec){var i=this.gridPanel.getStore().indexOf(rec);
if(i<(this.gridPanel.getStore().getCount()-1)){this.gridPanel.getStore().remove(rec);
this.gridPanel.getStore().insert(i+1,rec);
this.gridPanel.getSelectionModel().selectRecords([rec],false)
}}}},saveOrderResourceHandler:function(){var idList=[];
for(var i=0;
i<this.gridPanel.getStore().getCount();
i++){var rec=this.gridPanel.getStore().getAt(i);
if(rec.data.resourceURI!="new"){idList[idList.length]=rec.data.id
}}Sonatype.utils.defaultToNo();
Sonatype.MessageBox.show({animEl:this.gridPanel.getEl(),title:"Save Profile Order",msg:"Save the current order of the Profiles?",buttons:Sonatype.MessageBox.YESNO,scope:this,icon:Sonatype.MessageBox.QUESTION,fn:function(btnName){if(btnName=="yes"||btnName=="ok"){Ext.Ajax.request({callback:this.saveOrderCallback,scope:this,method:"POST",url:Sonatype.config.servicePath+"/staging/profile_order",jsonData:{data:idList}})
}}})
},saveOrderCallback:function(options,isSuccess,response){if(!isSuccess){Sonatype.utils.connectionError(response,"The server did not save the order of the profiles.")
}}});
Sonatype.Events.addListener("nexusNavigationPostInit",function(nexusPanel){nexusPanel.insert(2,{title:"Build Promotion",id:"st-enterprise-staging"});
nexusPanel.add({enabled:Sonatype.lib.Permissions.checkPermission("nexus:stagingprofiles",Sonatype.lib.Permissions.READ),sectionId:"st-enterprise-staging",title:"Staging Profiles",tabId:"stagingProfiles",tabCode:Sonatype.repoServer.StagingPanel})
});
Sonatype.Events.addListener("profileAddMenuInit",function(menu){var sp=Sonatype.lib.Permissions;
if(sp.checkPermission("nexus:stagingprofiles",sp.CREATE)){var createProfileFunc=function(container,rec,item,e){rec.beginEdit();
if(item.groupMode){rec.set("mode","GROUP")
}rec.set("resourceURI","new");
rec.set("targetGroups",[]);
rec.set("finishNotifyRoles",[]);
rec.set("promotionNotifyRoles",[]);
rec.commit();
rec.endEdit()
};
menu.add(["-",{text:"Staging Profile",autoCreateNewRecord:true,handler:createProfileFunc}]);
menu.add(["-",{text:"Build Promotion Profile",autoCreateNewRecord:true,handler:createProfileFunc,groupMode:true}])
}});
Sonatype.Events.addListener("privilegePanelInit",function(panel){var profileStore=new Ext.data.JsonStore({root:"data",id:"id",fields:[{name:"id"},{name:"name",sortType:Ext.data.SortTypes.asUCString}],sortInfo:{field:"name",direction:"asc"},url:Sonatype.config.servicePath+"/staging/profiles"});
panel.profileStore=profileStore;
panel.profileStore.load();
var func=function(value,parent){if(!Ext.isEmpty(value)){return this.convertDataValue(value,this.profileStore,"id","name")
}return""
};
panel.propertyTypeStore.add(new Ext.data.Record({"type":"profile","converter":func.createDelegate(panel)}))
});
Sonatype.repoServer.StagingRepositories=function(cfg){var config=cfg||{},defaultConfig={};
Ext.apply(this,config,defaultConfig);
this.gridPanel=new Sonatype.repoServer.StagingRepositoriesGrid({region:"center",parentPanel:this});
this.gridPanel.on("rowclick",this.gridPanel.rowclickHandler,this);
this.repositoryBrowser=new Sonatype.repoServer.RepositoryBrowsePanel({payload:null,tabTitle:"Browse",browseIndex:false,region:"center",nodeClickEvent:"stagingFileNodeClickedEvent",nodeClickPassthru:{container:this}});
this.artifactContainer=new Sonatype.repoServer.ArtifactContainer({collapsible:true,collapsed:true,region:"east",split:true,width:500,halfSize:true,initEventName:"fileContainerInit",updateEventName:"fileContainerUpdate"});
this.browserPanel=new Ext.Panel({title:"Browser",layout:"border",hideMode:"offsets",items:[this.repositoryBrowser,this.artifactContainer]});
this.groupPanel=new Sonatype.repoServer.StagingGroupRepositoryPanel({listeners:{click:function(node,evt){var container,content;
container=this.memberRepoDescription;
if(!node.attributes.description){container.collapse()
}else{content=new Ext.Panel({html:"<h1>"+node.attributes.serverText+"</h1><br/><p>"+Ext.util.Format.nl2br(node.attributes.description)+"</p>"});
container.removeAll(true);
container.add(content);
container.expand();
container.doLayout()
}},scope:this},region:"center"});
this.memberRepoDescription=new Ext.Panel({collapsible:true,collapsed:true,region:"east",split:true,width:"50%",halfSize:true,deferredRender:false,frame:true,collapseMode:"mini"});
this.groupContainerPanel=new Ext.Panel({title:"Group Members",layout:"border",hideMode:"offsets",items:[this.groupPanel,this.memberRepoDescription],parentPanel:this});
this.contentPanel=new Ext.TabPanel({region:"south",height:300,collapsible:true,collapsed:true,hideMode:"offsets",activeTab:0,split:true,items:[this.browserPanel,this.groupContainerPanel]});
Sonatype.repoServer.StagingRepositories.superclass.constructor.call(this,{layout:"border",hideMode:"offsets",items:[this.gridPanel,this.contentPanel]})
};
Ext.extend(Sonatype.repoServer.StagingRepositories,Ext.Panel,{});
Sonatype.repoServer.StagingRepositoriesGrid=function(cfg){var config=cfg||{},defaultConfig={};
Ext.apply(this,config,defaultConfig);
this.sp=Sonatype.lib.Permissions;
this.groupProfileStore=new Ext.data.SimpleStore({fields:[{name:"id"},{name:"name"}]});
this.profileStore=new Ext.data.JsonStore({root:"data",id:"resourceURI",fields:[{name:"resourceURI"},{name:"id"},{name:"name"},{name:"promotionTargetRepository"},{name:"mode"},{name:"repositoryType"}],url:Sonatype.config.servicePath+"/staging/profiles",autoLoad:true,listeners:{load:{fn:function(store,records,options){var i,rec;
this.groupProfileStore.removeAll();
for(i=0;
i<records.length;
i=i+1){if(records[i].get("mode")==="GROUP"){rec=records[i];
this.groupProfileStore.add(new Ext.data.Record([rec.get("id"),rec.get("name"),rec.get("description")]))
}}},scope:this},loadexception:{fn:function(){this.groupProfileStore.removeAll()
},scope:this}}});
this.stagedRepositoriesDS=new Ext.data.JsonStore({root:"data",id:"repositoryId",fields:[{name:"repositoryId"},{name:"profileId"},{name:"profileName"},{name:"profileType"},{name:"policy"},{name:"provider"},{name:"providerRole"},{name:"description"},{name:"type"},{name:"repositoryName",sortType:Ext.data.SortTypes.asUCString},{name:"description"},{name:"createdDate"},{name:"createdTimestamp"},{name:"closedDate"},{name:"closedTimestamp"},{name:"userId"},{name:"ipAddress"},{name:"userAgent"},{name:"repositoryURI"},{name:"releaseRepositoryName"},{name:"releaseRepositoryId"},{name:"parentGroupName"}],sortInfo:{field:"type",direction:"ASC"},url:Sonatype.config.servicePath+"/staging/profile_repositories",autoLoad:true,listeners:{load:{fn:function(store,records,options){this.getEl().unmask()
},scope:this},beforeload:{fn:function(store,options){this.getEl().mask("Loading repositories...","loading-indicator")
},scope:this},loadexception:{fn:function(){this.getEl().unmask()
},scope:this}}});
this.ds=this.stagedRepositoriesDS;
this.sm=new Ext.grid.CheckboxSelectionModel({listeners:{selectionchange:{fn:function(sm){var records,contentClass,i,rowCount=sm.getCount();
if(rowCount===0){Ext.getCmp("staging-close-button").disable();
Ext.getCmp("staging-promote-button").disable();
Ext.getCmp("staging-promote-group-button").disable();
Ext.getCmp("staging-drop-button").disable()
}else{if(this.sp.checkPermission("nexus:stagingfinish",this.sp.CREATE)){Ext.getCmp("staging-close-button").enable()
}if(this.sp.checkPermission("nexus:stagingpromote",this.sp.CREATE)){Ext.getCmp("staging-promote-button").enable()
}if(this.sp.checkPermission("nexus:stagingpromote",this.sp.CREATE)){Ext.getCmp("staging-promote-group-button").enable()
}if(this.sp.checkPermission("nexus:stagingdrop",this.sp.CREATE)){Ext.getCmp("staging-drop-button").enable()
}records=sm.getSelections();
contentClass=null;
for(i=0;
i<records.length;
i=i+1){if(contentClass===null){contentClass=records[i].get("provider")
}else{if(contentClass!==records[i].get("provider")){Ext.getCmp("staging-close-button").disable();
Ext.getCmp("staging-promote-button").disable();
Ext.getCmp("staging-promote-group-button").disable();
Ext.getCmp("staging-drop-button").disable();
break
}}if(records[i].get("type")==="open"){Ext.getCmp("staging-promote-button").disable();
Ext.getCmp("staging-promote-group-button").disable()
}else{if(records[i].get("type")==="closed"){Ext.getCmp("staging-close-button").disable()
}else{if(records[i].get("type")==="promoted"){Ext.getCmp("staging-close-button").disable();
Ext.getCmp("staging-promote-button").disable();
Ext.getCmp("staging-promote-group-button").disable();
Ext.getCmp("staging-drop-button").disable()
}}}}if(this.groupProfileStore.getCount()<1){Ext.getCmp("staging-promote-group-button").disable()
}}},scope:this}}});
this.cm=new Ext.grid.ColumnModel({columns:[this.sm,{id:"repositoryId",width:250,header:"Repository",dataIndex:"repositoryId",sortable:true,renderer:function(value,metadata,record){var uri,renderedValue=value+" (u:"+record.get("userId")+", a:"+record.get("ipAddress")+")";
if("open"===record.get("type")){return renderedValue
}uri=record.get("repositoryURI");
uri='<a href="'+uri+((uri&&(uri.charAt(uri.length))==="/")?"":"/")+'" target="_blank">'+renderedValue+"</a>";
if(record.get("profileType")==="group"){uri="<b>"+uri+"</b>"
}return uri
}},{id:"profileName",width:80,header:"Profile",dataIndex:"profileName",sortable:true},{id:"type",width:80,header:"Status",dataIndex:"type",sortable:true},{id:"releaseRepositoryName",width:110,header:"Release Repository",dataIndex:"releaseRepositoryName",sortable:true},{id:"parentGroupName",width:100,header:"Promoted To",dataIndex:"parentGroupName",sortable:true},{id:"createdTimestamp",width:170,header:"Created On",dataIndex:"createdTimestamp",sortable:true,renderer:function(value,panel,record){return value===-1?"n/a":new Date(value)
}},{id:"closedTimestamp",width:170,header:"Closed On",dataIndex:"closedTimestamp",sortable:true,renderer:function(value,panel,record){return value===-1?"n/a":new Date(value)
}},{id:"userAgent",width:100,header:"User Agent",dataIndex:"userAgent",sortable:true},{id:"description",width:100,header:"Description",dataIndex:"description",sortable:true}]});
this.autoExpandColumn="description";
this.filterLovCombo=new Ext.ux.form.LovCombo({triggerAction:"all",mode:"remote",hideOnSelect:false,maxHeight:200,width:350,store:this.profileStore,valueField:"id",displayField:"name",allowBlank:true,editable:false,emptyText:"Select one or more Staging profiles or none to show all...",lastQuery:"",listeners:{select:{fn:function(combo,record,index){var value=combo.getValue();
if(value===""){this.stagedRepositoriesDS.clearFilter(false)
}else{this.stagedRepositoriesDS.filterBy(function(rec,id){return value.indexOf(rec.get("profileId"))!==-1
})
}},scope:this}}});
this.tbar=[{text:"Refresh",tooltip:"Refresh the content of the panel",iconCls:"st-icon-refresh",handler:this.refreshHandler,scope:this},"-",{text:"Close",id:"staging-close-button",tooltip:"Close the selected staging repositories",handler:this.closeHandler,scope:this,disabled:true},"-",{text:"Release",id:"staging-promote-button",tooltip:"Release the selected staging repositories",handler:this.promoteHandler,scope:this,disabled:true},"-",{text:"Drop",id:"staging-drop-button",tooltip:"Drop the selected staging repositories",handler:this.dropHandler,scope:this,disabled:true},"-",{text:"Promote",id:"staging-promote-group-button",tooltip:"Promote the selected staging repositories",handler:this.promoteToGroupHandler,scope:this,disabled:true},"-",this.filterLovCombo];
Sonatype.repoServer.StagingRepositoriesGrid.superclass.constructor.call(this,{})
};
Ext.extend(Sonatype.repoServer.StagingRepositoriesGrid,Ext.grid.GridPanel,{refreshHandler:function(button,event){this.resetSelectionContent();
this.filterLovCombo.reset();
this.profileStore.reload();
this.store.reload()
},resetSelectionContent:function(){var sm=this.getSelectionModel();
sm.clearSelections();
sm.fireEvent("selectionchange",sm);
this.resetRepositoryBrowser(this);
this.current=-1
},closeHandler:function(button,event){var i,records=this.getSelectionModel().getSelections(),recordIds=[];
for(i=0;
i<records.length;
i=i+1){recordIds.push(records[i].get("repositoryId"))
}new Sonatype.repoServer.ManageRepositoryWindow({title:"Close Staging "+((records.length>1)?"Repositories":"Repository"),buttonText:"Close",callback:this.closeCallback,resourceURI:Sonatype.config.servicePath+"/staging/bulk/close",waitMessage:"Closing, please wait",panel:this,records:records,recordIds:recordIds}).show()
},closeCallback:function(options,isSuccess,response){var i;
Ext.Msg.hide();
options.cbPassThru.window.close();
if(!isSuccess){if(response.responseText.indexOf("failures")!==-1){options.cbPassThru.panel.showRulesetEvaluationReport(response.responseText)
}else{Sonatype.utils.connectionError(response,"The server did not close the staging repository.",false,options.options)
}}else{for(i=0;
i<options.cbPassThru.records.length;
i=i+1){options.cbPassThru.records[i].beginEdit();
options.cbPassThru.records[i].set("type","closed");
options.cbPassThru.records[i].set("description",options.cbPassThru.description);
options.cbPassThru.records[i].set("closedDate",new Date().format("D M d G:i:s T Y"));
options.cbPassThru.records[i].commit();
options.cbPassThru.records[i].endEdit()
}Sonatype.MessageBox.show({title:"Close completed",msg:"The selected staging repositories have been closed.",buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.INFO,animEl:"mb3",fn:options.cbPassThru.panel.refreshHandler,scope:options.cbPassThru.panel})
}},promoteHandler:function(button,event){var i,profileRecord,records=this.getSelectionModel().getSelections(),validPromotion=true,recordIds=[];
for(i=0;
i<records.length;
i=i+1){recordIds.push(records[i].get("repositoryId"));
profileRecord=this.profileStore.getAt(this.profileStore.find("id",records[i].get("profileId")));
if(profileRecord.get("mode")!=="GROUP"&&Ext.isEmpty(profileRecord.get("promotionTargetRepository"))){Sonatype.MessageBox.show({title:"Promotion Repository Unavailable",msg:"The staging profile "+records[i].get("profileName")+" has no Promotion Repository defined, promotion cannot be completed.",buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.ERROR,animEl:"mb3"});
validPromotion=false;
break
}}if(validPromotion){new Sonatype.repoServer.ManageRepositoryWindow({title:"Release Staging "+((records.length>1)?"Repositories":"Repository"),buttonText:"Release",callback:this.promoteCallback,resourceURI:Sonatype.config.servicePath+"/staging/bulk/promote",waitMessage:"Releasing, please wait",panel:this,records:records,recordIds:recordIds}).show()
}},promoteCallback:function(options,isSuccess,response){Ext.Msg.hide();
options.cbPassThru.window.close();
var panel=options.cbPassThru.panel;
if(!isSuccess){if(response.responseText.indexOf("failures")!==-1){options.cbPassThru.panel.showRulesetEvaluationReport(response.responseText)
}else{Sonatype.utils.connectionError(response,"The server did not promote the staged repository.",false,options.options)
}}else{Sonatype.MessageBox.show({title:"Release Complete",msg:"The selected repositories have successfully been released.",buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.INFO,animEl:"mb3",fn:options.cbPassThru.panel.refreshHandler,scope:options.cbPassThru.panel})
}},dropHandler:function(rec){var i,records=this.getSelectionModel().getSelections(),recordIds=[];
for(i=0;
i<records.length;
i=i+1){recordIds.push(records[i].get("repositoryId"))
}new Sonatype.repoServer.ManageRepositoryWindow({title:"Drop Staging "+((records.length>1)?"Repositories":"Repository"),buttonText:"Drop",callback:this.dropCallback,resourceURI:Sonatype.config.servicePath+"/staging/bulk/drop",waitMessage:"Dropping, please wait",panel:this,records:records,recordIds:recordIds}).show()
},dropCallback:function(options,isSuccess,response){Ext.Msg.hide();
options.cbPassThru.window.close();
var panel=options.cbPassThru.panel;
if(!isSuccess){Sonatype.utils.connectionError(response,"The server did not drop the repository.",false,options.options)
}else{Sonatype.MessageBox.show({title:"Staging Repository Dropped",msg:"The staging repository has successfully been dropped.",buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.INFO,animEl:"mb3",fn:options.cbPassThru.panel.refreshHandler,scope:options.cbPassThru.panel})
}},promoteToGroupHandler:function(button,event){var i,records=this.getSelectionModel().getSelections(),recordIds=[],dataArray=[],provider=records[0].get("provider");
for(i=0;
i<records.length;
i=i+1){recordIds.push(records[i].get("repositoryId"))
}this.profileStore.each(function(rec){if(rec.get("mode")!=="GROUP"){return
}if(rec.get("repositoryType")!==provider){return
}if(records.length===1&&records[0].get("profileName")===rec.get("name")){return
}dataArray.push([rec.get("id"),rec.get("name")])
});
new Sonatype.repoServer.ManageRepositoryWindow({title:"Promote Staging "+((records.length>1)?"Repositories":"Repository")+".",buttonText:"Promote",callback:this.promoteToGroupCallback,resourceURI:Sonatype.config.servicePath+"/staging/bulk/promote",waitMessage:"Promoting, please wait",panel:this,records:records,recordIds:recordIds,buildJsonData:function(){return{data:{stagedRepositoryIds:this.recordIds,stagingProfileGroup:this.find("name","stagingProfile")[0].getValue(),description:this.find("name","description")[0].getValue()}}
},extraItems:[{xtype:"panel",style:"padding-bottom: 10px",html:"Select the build promotion profile that you want to promote these repositories into.  This will create a new build promotion repository."},{xtype:"combo",fieldLabel:"Build Promotion Profile",itemCls:"required-field",helpText:"Build promotion profile that will be used to create a new build promotion repository, containing the selected staging repositories.",name:"stagingProfile",store:dataArray,displayField:"name",valueField:"id",editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false,required:true,width:180}]}).show()
},promoteToGroupCallback:function(options,isSuccess,response){Ext.Msg.hide();
options.cbPassThru.window.close();
if(!isSuccess){if(response.responseText.indexOf("failures")!==-1){options.cbPassThru.panel.showRulesetEvaluationReport(response.responseText)
}else{Sonatype.utils.connectionError(response,"The server did not promote to a new Build Promotion Repository.",false,options.options)
}}else{Sonatype.MessageBox.show({title:"Promotion completed",msg:"The selected staging repositories have been promoted to a new build promotion repository, the panel has been refreshed to show the changes.",buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.INFO,animEl:"mb3",fn:options.cbPassThru.panel.refreshHandler,scope:options.cbPassThru.panel})
}},rowclickHandler:function(grid,rowIndex){if(grid.current===rowIndex){return
}grid.current=rowIndex;
var reporec,isGroup,rec=grid.getStore().getAt(rowIndex);
reporec={data:{resourceURI:Sonatype.config.host+Sonatype.config.repos.urls.repositories+"/"+rec.data.repositoryId,name:rec.data.repositoryId+" (u:"+rec.data.userId+", a:"+rec.data.ipAddress+")",repositoryURI:Sonatype.config.host+Sonatype.config.repos.urls.repositories+"/"+rec.data.repositoryId,repoType:"hosted",exposed:false,contentResourceURI:rec.data.repositoryURI,showCtx:true},get:function(field){return this.data[field]
}};
this.contentPanel.expand();
this.artifactContainer.collapsePanel();
this.repositoryBrowser.updatePayload(reporec);
isGroup=grid.profileStore.getAt(grid.profileStore.findBy(function(record,id){if(record.get("id")===rec.get("profileId")){return true
}return false
})).get("mode")==="GROUP";
if(isGroup){this.contentPanel.unhideTabStripItem(this.groupContainerPanel);
this.groupPanel.updateMembers({groupId:rec.get("repositoryId"),groupName:rec.get("repositoryName")})
}else{this.groupPanel.updateMembers(null);
this.contentPanel.hideTabStripItem(this.groupContainerPanel);
this.contentPanel.setActiveTab(0)
}},resetRepositoryBrowser:function(gridPanel){gridPanel.parentPanel.repositoryBrowser.updatePayload(null);
gridPanel.parentPanel.artifactContainer.collapsePanel();
gridPanel.parentPanel.contentPanel.collapse()
}});
Nexus.staging.Rules.treat(Sonatype.repoServer.StagingRepositoriesGrid);
Sonatype.repoServer.ManageRepositoryWindow=function(cfg){var i,text,items=[],config=cfg||{},defaultConfig={};
Ext.apply(this,config,defaultConfig);
text="You are about to <b>"+config.buttonText.toLowerCase()+"</b> "+config.records.length+" repositories:";
for(i=0;
i<config.records.length;
i=i+1){text+="<p>&nbsp; &nbsp; &nbsp; "+config.records[i].get("repositoryName")+"</p>"
}items.push({xtype:"panel",style:"padding-bottom: 10px",html:text});
if(this.extraItems){for(i=0;
i<this.extraItems.length;
i=i+1){items.push(this.extraItems[i])
}}items.push({xtype:"textarea",fieldLabel:"Description",helpText:"A detailed description of the staging repositories selected",anchor:Sonatype.view.FIELD_OFFSET,name:"description",allowBlank:true});
Sonatype.repoServer.ManageRepositoryWindow.superclass.constructor.call(this,{autoHeight:true,autoWidth:false,width:400,modal:true,constrain:true,resizable:false,draggable:false,items:[{xtype:"form",labelWidth:110,frame:true,defaultType:"textfield",monitorValid:true,items:items,buttons:[{text:this.buttonText,formBind:true,scope:this,handler:function(){Ext.Ajax.request({scope:this,method:"POST",options:{dontForceLogout:true},timeout:Ext.Ajax.timeout*10,cbPassThru:{records:this.records,description:this.find("name","description")[0].getValue(),window:this,panel:this.panel},callback:this.callback,jsonData:this.buildJsonData(),url:this.resourceURI});
Ext.Msg.show({wait:true,msg:this.waitMessage})
}},{text:"Cancel",formBind:false,scope:this,handler:function(){this.close()
}}]}]})
};
Ext.extend(Sonatype.repoServer.ManageRepositoryWindow,Ext.Window,{buildJsonData:function(){return{data:{stagedRepositoryIds:this.recordIds,description:this.find("name","description")[0].getValue()}}
}});
Sonatype.repoServer.StagingGroupRepositoryPanel=function(cfg){var config=cfg||{},StagingGroupMemberTreeLoader,defaultConfig={layout:"fit"};
Ext.apply(this,config,defaultConfig);
this.store=new Ext.data.SimpleStore({fields:[{name:"id"},{name:"name"},{name:"description"}]});
StagingGroupMemberTreeLoader=Ext.extend(Ext.tree.SonatypeTreeLoader,{createNode:function(attr){if(attr.description){attr.serverText=attr.text;
attr.text=attr.text+" ("+Ext.util.Format.ellipsis(attr.description.split("\n")[0],50)+")"
}return StagingGroupMemberTreeLoader.superclass.createNode.apply(this,arguments)
}});
Sonatype.repoServer.StagingGroupRepositoryPanel.superclass.constructor.call(this,{animate:true,lines:false,autoScroll:true,containerScroll:true,root:new Ext.tree.TreeNode({text:""}),rootVisible:true,enableDD:false,tbar:[{text:"Refresh",icon:Sonatype.config.resourcePath+"/images/icons/arrow_refresh.png",cls:"x-btn-text-icon",scope:this,handler:this.refreshHandler}],loader:new StagingGroupMemberTreeLoader({url:"",listeners:{loadexception:this.treeLoadExceptionHandler,scope:this}})})
};
Ext.extend(Sonatype.repoServer.StagingGroupRepositoryPanel,Ext.tree.TreePanel,{refreshHandler:function(button,e){if(this.getRootNode().reload){this.getRootNode().reload()
}},updateMembers:function(data){if(this.root){this.root.destroy()
}if(!data){this.setRootNode(new Ext.tree.TreeNode({text:""}))
}else{this.setRootNode(new Ext.tree.AsyncTreeNode({text:data.groupName,id:Sonatype.config.servicePath+"/staging/profile_repositories/tree/"+data.groupId+"/",expanded:true}))
}if(this.innerCt){this.innerCt.update("");
this.afterRender()
}},treeLoadExceptionHandler:function(treeLoader,node,response){if(response.status===503){if(Sonatype.MessageBox.isVisible()){Sonatype.MessageBox.hide()
}node.setText(node.text+" (Out of Service)")
}else{if(response.status===404||response.status===400){if(Sonatype.MessageBox.isVisible()){Sonatype.MessageBox.hide()
}node.setText(node.text+(node.isRoot?" (Not Available)":" (Not Found)"))
}else{if(response.status===401||response.status===403){if(Sonatype.MessageBox.isVisible()){Sonatype.MessageBox.hide()
}node.setText(node.text+" (Access Denied)")
}}}}});
Sonatype.Events.addListener("stagingFileNodeClickedEvent",function(node,passthru){if(passthru&&passthru.container&&passthru.container.artifactContainer.items.getCount()>0){if(node&&node.isLeaf()){passthru.container.artifactContainer.updateArtifact({text:node.attributes.text,leaf:node.attributes.leaf,resourceURI:node.attributes.resourceURI})
}else{passthru.container.artifactContainer.collapsePanel()
}}});
Sonatype.Events.addListener("nexusNavigationInit",function(nexusPanel){nexusPanel.add({enabled:Sonatype.lib.Permissions.checkPermission("nexus:stagingprofilerepos",Sonatype.lib.Permissions.READ),sectionId:"st-enterprise-staging",title:"Staging Repositories",tabId:"stagingRepositories",tabCode:Sonatype.repoServer.StagingRepositories})
});
Sonatype.repoServer.ProfileEditor=function(cfg){var config=cfg||{},defaultConfig={uri:Sonatype.config.servicePath+"/staging/profiles",resetButton:true,defaultTimeoutValues:{},dataModifiers:{load:{finishNotifyRoles:function(arr,srcObj,fpanel){fpanel.find("name","finishRoleManager")[0].setSelectedRoleIds(arr,true);
return arr
},promotionNotifyRoles:function(arr,srcObj,fpanel){fpanel.find("name","promotionRoleManager")[0].setSelectedRoleIds(arr,true);
return arr
},dropNotifyRoles:function(arr,srcObj,fpanel){fpanel.find("name","dropRoleManager")[0].setSelectedRoleIds(arr,true);
return arr
},targetGroups:this.importGroupsHelper.createDelegate(this),closeRuleSets:this.importCloseRuleSetsHelper.createDelegate(this),promoteRuleSets:this.importPromoteRuleSetsHelper.createDelegate(this)},submit:{finishNotifyRoles:function(value,fpanel){return fpanel.find("name","finishRoleManager")[0].getSelectedRoleIds()
},promotionNotifyRoles:function(value,fpanel){return fpanel.find("name","promotionRoleManager")[0].getSelectedRoleIds()
},dropNotifyRoles:function(value,fpanel){return fpanel.find("name","dropRoleManager")[0].getSelectedRoleIds()
},targetGroups:this.exportGroupsHelper.createDelegate(this),closeRuleSets:this.exportCloseRuleSetsHelper.createDelegate(this),promoteRuleSets:this.exportPromoteRuleSetsHelper.createDelegate(this),autoStagingDisabled:function(value,fpanel){if(value===true||value===false){return value
}else{return"true"===value
}},repositoriesSearchable:function(value,fpanel){if(value===true||value===false){return value
}else{return"false"===value
}}}},referenceData:{id:"",name:"",repositoryTemplateId:"",repositoryType:"",repositoryTargetId:"",targetGroups:[],finishNotifyRoles:[],promotionNotifyRoles:[],dropNotifyRoles:[],finishNotifyEmails:"",promotionNotifyEmails:"",dropNotifyEmails:"",closeRuleSets:[],promoteRuleSets:[],promotionTargetRepository:"",dropNotifyCreator:true,finishNotifyCreator:true,promotionNotifyCreator:true,autoStagingDisabled:false,repositoriesSearchable:true,mode:""}};
Ext.apply(this,config,defaultConfig);
this.currentTemplate=undefined;
this.selectionStrategyStore=new Ext.data.SimpleStore({fields:["value","display"],data:[[false,"Explicit or Implicit - selected by ID or Nexus will calculate match"],[true,"Explicit Only - only selected by ID"]]});
this.templateStore=new Ext.data.JsonStore({root:"data",id:"id",fields:[{name:"resourceURI"},{name:"repoType"},{name:"repoPolicy"},{name:"id"},{name:"name",sortType:Ext.data.SortTypes.asUCString,convert:this.calculateTemplateName},{name:"format"}],sortInfo:{field:"name",direction:"ASC"},url:Sonatype.config.repos.urls.repoTemplates,autoLoad:false,listeners:{load:{fn:function(store,records,options){Sonatype.repoServer.ProfileEditor.prototype.repositoryTemplateFilter(store);
var combo=this.find("name","repositoryTemplateId")[0],nameField=this.find("name","name")[0];
combo.doQuery(combo.allQuery,true);
nameField.focus()
},scope:this}}});
this.rulesetStore=new Ext.data.JsonStore({root:"data",id:"id",fields:[{name:"id"},{name:"name",sortType:Ext.data.SortTypes.asUCString}],sortInfo:{field:"name",direction:"ASC"},url:Sonatype.config.servicePath+"/staging/rule_sets",autoLoad:false});
this.repoTypeStore=new Ext.data.JsonStore({root:"data",id:"roleHint",fields:[{name:"description"},{name:"roleHint",sortType:Ext.data.SortTypes.asUCString}],sortInfo:{field:"description",direction:"ASC"},url:Sonatype.config.repos.urls.repoTypes,autoLoad:false});
this.checkPayload();
this.COMBO_WIDTH=376;
this.items=[];
if(!this.isNew){if(!this.groupProfile){this.items.push({xtype:"panel",layout:"column",items:[{xtype:"panel",html:"Profile ID",height:21,width:205},{xtype:"panel",html:this.payload.get("id")}]});
this.items.push({xtype:"panel",layout:"column",items:[{xtype:"panel",html:"Deploy URL",height:21,width:205},{xtype:"panel",html:this.payload.get("deployURI")}]})
}else{this.items.push({xtype:"panel",layout:"column",items:[{xtype:"panel",html:"Profile ID",height:21,width:205},{xtype:"panel",html:this.payload.get("id")}]})
}}this.items.push({xtype:"textfield",fieldLabel:"Profile Name",itemCls:"required-field",helpText:"Staging profile name.",name:"name",width:this.COMBO_WIDTH,allowBlank:false,disabled:!this.isNew});
if(this.groupProfile){this.items.push({xtype:"textfield",fieldLabel:"Staging Mode",itemCls:"required-field",helpText:"The source(s) this profile will accept artifacts from, either from the staging deploy URL, or staging upload via the UI, or both.",name:"modeInput",width:this.COMBO_WIDTH,allowBlank:false,disabled:true},{xtype:"hidden",name:"mode"},{xtype:"hidden",value:false,name:"autoStagingDisabled"},{xtype:"hidden",value:true,name:"repositoriesSearchable"})
}else{this.items.push({xtype:"combo",fieldLabel:"Profile Selection Strategy",itemCls:"required-field",helpText:"'Explicit or Implicit' will include this profile as a possible match using user agent, IP address, username and repository target if the profile ID is not specified explicitly. 'Explicit Only' means this profile will only be selected when identified by profile ID.",name:"autoStagingDisabledComboName",hiddenName:"autoStagingDisabled",store:this.selectionStrategyStore,displayField:"display",valueField:"value",width:this.COMBO_WIDTH,listWidth:this.COMBO_WIDTH,editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false});
this.items.push({xtype:"checkbox",checked:true,fieldLabel:"Searchable Repositories",itemCls:"required-field",helpText:"When enabled, repositories created using this profile are indexed and searchable. Setting applies only to new repositories.",name:"repositoriesSearchable",width:this.COMBO_WIDTH});
this.items.push({xtype:"combo",fieldLabel:"Staging Mode",itemCls:"required-field",helpText:"The source(s) this profile will accept artifacts from, either from the staging deploy URL, or staging upload via the UI, or both.",name:"mode",store:this.modeStore,displayField:"display",valueField:"value",width:this.COMBO_WIDTH,listWidth:this.COMBO_WIDTH,editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false})
}this.items.push({xtype:"combo",fieldLabel:"Template",itemCls:"required-field",helpText:"Template used to create staging repositories.",name:"repositoryTemplateId",width:this.COMBO_WIDTH,listWidth:this.COMBO_WIDTH,store:this.templateStore,displayField:"name",valueField:"id",editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false,listeners:{select:{fn:this.templateSelectHandler,scope:this}}});
if(!this.groupProfile){this.items.push({xtype:"combo",fieldLabel:"Repository Target",itemCls:"required-field",helpText:"Repository target that will cause this profile to be selected.",name:"repositoryTargetId",store:this.targetStore,displayField:"name",valueField:"id",width:this.COMBO_WIDTH,listWidth:this.COMBO_WIDTH,editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false,lastQuery:""});
this.items.push({xtype:"combo",fieldLabel:"Release Repository",helpText:"A Repository that will be used to release all staged repositories to.",name:"promotionTargetRepository",width:this.COMBO_WIDTH,itemCls:"required-field",listWidth:this.COMBO_WIDTH,store:this.filteredRepoStore,displayField:"name",valueField:"id",editable:false,forceSelection:false,mode:"local",required:true,triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false,lastQuery:""})
}this.items.push({xtype:"textfield",fieldLabel:"Content Type",itemCls:"required-field",helpText:'The type of the generated staging repositories (e.g. "maven1", "maven2").',name:"repositoryType",width:this.COMBO_WIDTH,allowBlank:false,disabled:true},{xtype:"twinpanelchooser",titleLeft:"Target Groups",titleRight:"Available Groups",name:"targetGroups",valueField:"id",store:this.groupStore,halfSize:true,required:true},{xtype:"fieldset",checkboxToggle:false,title:"Close Repository Notification Settings",anchor:Sonatype.view.FIELDSET_OFFSET,collapsible:true,autoHeight:true,layoutConfig:{labelSeparator:""},items:[{xtype:"textfield",fieldLabel:"Email Addresses",helpText:"Comma seperated list of email addresses to send notifications to.",name:"finishNotifyEmails",width:this.COMBO_WIDTH},{xtype:"rolemanager",name:"finishRoleManager",height:200,width:581,usePrivileges:false,doValidation:false,style:"margin-top: 10px;border: 1px solid #B5B8C8;"},{xtype:"checkbox",checked:true,fieldLabel:"Notify creator",helpText:"Notify the repository creator (the user who uploaded the repository content) if the repository gets closed.",name:"finishNotifyCreator",width:this.COMBO_WIDTH}]},{xtype:"fieldset",checkboxToggle:false,title:"Promote Repository Notification Settings",anchor:Sonatype.view.FIELDSET_OFFSET,collapsible:true,autoHeight:true,layoutConfig:{labelSeparator:""},items:[{xtype:"textfield",fieldLabel:"Email Addresses",helpText:"Comma seperated list of email addresses to send notifications to.",name:"promotionNotifyEmails",width:this.COMBO_WIDTH},{xtype:"rolemanager",name:"promotionRoleManager",height:200,width:581,usePrivileges:false,doValidation:false,style:"margin-top: 10px;border: 1px solid #B5B8C8;"},{xtype:"checkbox",checked:true,fieldLabel:"Notify creator",helpText:"Notify the repository creator (the user who uploaded the repository content) if the repository gets promoted.",name:"promotionNotifyCreator",width:this.COMBO_WIDTH}]},{xtype:"fieldset",checkboxToggle:false,title:"Drop Repository Notification Settings",anchor:Sonatype.view.FIELDSET_OFFSET,collapsible:true,autoHeight:true,layoutConfig:{labelSeparator:""},items:[{xtype:"textfield",fieldLabel:"Email Addresses",helpText:"Comma seperated list of email addresses to send notifications to.",name:"dropNotifyEmails",width:this.COMBO_WIDTH},{xtype:"rolemanager",name:"dropRoleManager",height:200,width:581,usePrivileges:false,doValidation:false,style:"margin-top: 10px;border: 1px solid #B5B8C8;"},{xtype:"checkbox",checked:true,fieldLabel:"Notify creator",helpText:"Notify the repository creator (the user who uploaded the repository content) if the repository gets dropped.",name:"dropNotifyCreator",width:this.COMBO_WIDTH}]},{xtype:"fieldset",checkboxToggle:false,title:"Close Repository Staging Rulesets",anchor:Sonatype.view.FIELDSET_OFFSET,collapsible:true,autoHeight:true,layoutConfig:{labelSeparator:""},items:[{xtype:"twinpanelchooser",titleLeft:"Rulesets",titleRight:"Available Rulesets",name:"closeRuleSets",valueField:"id",store:this.rulesetStore,halfSize:true}]},{xtype:"fieldset",checkboxToggle:false,title:"Promote Repository Staging Rulesets",anchor:Sonatype.view.FIELDSET_OFFSET,collapsible:true,autoHeight:true,layoutConfig:{labelSeparator:""},items:[{xtype:"twinpanelchooser",titleLeft:"Rulesets",titleRight:"Available Rulesets",name:"promoteRuleSets",valueField:"id",store:this.rulesetStore,halfSize:true}]},{xtype:"hidden",name:"id"});
Sonatype.repoServer.ProfileEditor.superclass.constructor.call(this,{dataStores:[this.templateStore,this.rulesetStore,this.repoTypeStore],listeners:{submit:{fn:this.submitHandler,scope:this},load:{fn:this.loadHandler,scope:this}}})
};
Ext.extend(Sonatype.repoServer.ProfileEditor,Sonatype.ext.FormPanel,{loadData:function(){if(this.isNew){this.form.reset();
this.fireEvent("load",this.form)
}else{this.form.doAction("sonatypeLoad",{url:this.getActionURL(),method:"GET",fpanel:this,dataModifiers:this.dataModifiers.load,scope:this})
}},isValid:function(){return this.form.isValid()&&this.find("name","targetGroups")[0].validate()
},loadHandler:function(form,action,receivedData){if(this.groupProfile){this.find("name","modeInput")[0].setRawValue("Group");
this.find("name","mode")[0].setRawValue("GROUP");
this.templateStore.filterBy(function(rec,id){return rec.get("repoType")==="group"
})
}else{this.templateStore.filterBy(function(rec,id){return rec.get("repoType")==="hosted"&&(rec.get("format")==="maven1"||rec.get("format")==="maven2")
});
if(receivedData){var templateRec=this.templateStore.getById(receivedData.repositoryTemplateId);
this.filterTemplateSelectHandler(templateRec)
}}},submitHandler:function(form,action,receivedData){if(this.isNew){receivedData.sTargetGroups=this.joinGroups(receivedData.targetGroups);
receivedData.sTarget=this.getRepositoryTarget(receivedData.repositoryTargetId);
receivedData.sPromotionTargetRepository=this.getRepoName(receivedData.promotionTargetRepository);
receivedData.sMode=this.getModeName(receivedData.mode);
return
}var rec=this.payload;
rec.beginEdit();
rec.set("name",receivedData.name);
rec.set("repositoryTemplateId",receivedData.repositoryTemplateId);
rec.set("repositoryType",receivedData.repositoryType);
rec.set("targetGroups",receivedData.targetGroups);
rec.set("sTargetGroups",this.joinGroups(receivedData.targetGroups));
rec.set("currentRepositoryIds",receivedData.currentRepositoryIds);
rec.set("inProgress",receivedData.inProgress);
rec.set("repositoryTargetId",receivedData.repositoryTargetId);
rec.set("sTarget",this.getRepositoryTarget(receivedData.repositoryTargetId));
rec.set("finishNotifyRoles",receivedData.finishNotifyRoles);
rec.set("promotionNotifyRoles",receivedData.promotionNotifyRoles);
rec.set("dropNotifyRoles",receivedData.dropNotifyRoles);
rec.set("closeRuleSets",receivedData.closeRuleSets);
rec.set("promoteRuleSets",receivedData.promoteRuleSets);
rec.set("promotionTargetRepository",receivedData.promotionTargetRepository);
rec.set("sPromotionTargetRepository",this.getRepoName(receivedData.promotionTargetRepository));
rec.set("mode",receivedData.mode);
rec.set("sMode",this.getModeName(receivedData.mode));
rec.set("deployURI",receivedData.deployURI);
rec.commit();
rec.endEdit()
},exportGroupsHelper:function(value,formPanel){return formPanel.find("name","targetGroups")[0].getValue()
},importGroupsHelper:function(value,parent,formPanel){formPanel.find("name","targetGroups")[0].setValue(value);
return value
},importCloseRuleSetsHelper:function(value,parent,formPanel){formPanel.find("name","closeRuleSets")[0].setValue(value);
return value
},exportCloseRuleSetsHelper:function(value,formPanel){return formPanel.find("name","closeRuleSets")[0].getValue()
},importPromoteRuleSetsHelper:function(value,parent,formPanel){formPanel.find("name","promoteRuleSets")[0].setValue(value);
return value
},exportPromoteRuleSetsHelper:function(value,formPanel){return formPanel.find("name","promoteRuleSets")[0].getValue()
},filterTemplateSelectHandler:function(record){this.currentTemplate=record.get("id");
var format=record.get("format");
if(this.payload.get("mode")!=="GROUP"){this.targetStore.filterBy(function(rec,id){return rec.get("contentClass")===format
});
this.filteredRepoStore.filterBy(function(rec,id){return rec.get("format")===format
});
this.groupStore.filterBy(function(rec,id){return rec.get("format")===format
})
}},templateSelectHandler:function(combo,record,index){var reset=this.currentTemplate!==record.get("id"),groupsField=this.find("name","targetGroups")[0],format=record.get("format");
this.filterTemplateSelectHandler(record);
if(reset&&this.payload.get("mode")!=="GROUP"){this.find("name","repositoryTargetId")[0].reset();
this.find("name","promotionTargetRepository")[0].reset()
}if(reset){groupsField.setValue([]);
groupsField.loadStore();
groupsField.clearInvalid()
}this.find("name","repositoryType")[0].setRawValue(format)
},repositoryTemplateFilter:function(store){var rec,policy,i,records;
records=store.getRange();
for(i=records.length-1;
i>=0;
i=i-1){rec=records[i];
policy=rec.get("repoPolicy");
if(!(rec.get("format")==="maven2"&&rec.get("repoType")!=="proxy"&&(policy==="RELEASE"||policy===""))){store.remove(rec)
}}}});
Sonatype.Events.addListener("profileViewInit",function(cardPanel,rec,gridPanel){var sp=Sonatype.lib.Permissions,data=[],repoData,filteredRepoStore,i,repoRec;
if(sp.checkPermission("nexus:stagingprofiles",sp.READ)&&(sp.checkPermission("nexus:stagingprofiles",sp.CREATE)||sp.checkPermission("nexus:stagingprofiles",sp.DELETE)||sp.checkPermission("nexus:stagingprofiles",sp.EDIT))){for(i=0;
i<gridPanel.repoStore.getCount();
i=i+1){repoRec=gridPanel.repoStore.getAt(i);
if(repoRec.get("repoType")==="hosted"&&repoRec.get("repoPolicy")!=="SNAPSHOT"){repoData=[repoRec.get("id"),repoRec.get("name"),repoRec.get("format")];
data.push(repoData)
}}filteredRepoStore=new Ext.data.SimpleStore({fields:[{name:"id"},{name:"name"},{name:"format"},{name:"repoPolicy"}],data:data});
cardPanel.add(new Sonatype.repoServer.ProfileEditor({name:"configuration",groupStore:gridPanel.groupStore,targetStore:gridPanel.targetStore,repoStore:gridPanel.repoStore,filteredRepoStore:filteredRepoStore,joinGroups:gridPanel.joinGroups,modeStore:gridPanel.modeStore,fullModeStore:gridPanel.fullModeStore,getRepositoryTarget:gridPanel.getRepositoryTarget,getRepoName:gridPanel.getRepoName,getModeName:gridPanel.getModeName,tabTitle:"Configuration",payload:rec,groupProfile:rec.get("mode")==="GROUP"}))
}});
Sonatype.repoServer.StagingRuleSet=function(cfg){var config=cfg||{},defaultConfig={title:"Staging Ruleset"},sp=Sonatype.lib.Permissions,toolbar=[];
Ext.apply(this,config,defaultConfig);
Sonatype.repoServer.StagingPanel.superclass.constructor.call(this,{url:Sonatype.config.servicePath+"/staging/rule_sets",tbar:toolbar,dataAutoLoad:false,tabbedChildren:true,addMenuInitEvent:"rulesetAddMenuInit",deleteButton:sp.checkPermission("nexus:stagingrulesets",sp.DELETE),rowClickEvent:"rulesetViewInit",dataSortInfo:{field:"name",direction:"asc"},columns:[{name:"resourceURI"},{name:"id"},{name:"name",header:"Name",width:100},{name:"description",header:"Description",width:200},{name:"rules"}]});
this.dataStore.load()
};
Ext.extend(Sonatype.repoServer.StagingRuleSet,Sonatype.panels.GridViewer,{});
Sonatype.Events.addListener("nexusNavigationInit",function(nexusPanel){nexusPanel.add({enabled:Sonatype.lib.Permissions.checkPermission("nexus:stagingrulesets",Sonatype.lib.Permissions.READ),sectionId:"st-enterprise-staging",title:"Staging Ruleset",tabId:"staging-ruleset",tabCode:Sonatype.repoServer.StagingRuleSet})
});
Sonatype.Events.addListener("rulesetAddMenuInit",function(menu){var sp=Sonatype.lib.Permissions;
if(sp.checkPermission("nexus:stagingrulesets",sp.CREATE)){menu.add(["-",{text:"Ruleset",autoCreateNewRecord:true,handler:function(container,rec,item,e){rec.beginEdit();
rec.set("resourceURI","new");
rec.set("rules",[]);
rec.commit();
rec.endEdit()
}}])
}});
Sonatype.repoServer.RulesetEditor=function(cfg){var config=cfg||{},defaultConfig={region:"center",width:"100%",height:"100%",autoScroll:true,border:false,frame:true,collapsible:false,collapsed:false,buttonAlign:"center"},checkColumn=new Ext.grid.CheckColumn({header:"Enabled",dataIndex:"enabled",width:60});
Ext.apply(this,config,defaultConfig);
this.isNew=this.payload.data.id?false:true;
this.ruleTypeDataStore=new Ext.data.JsonStore({root:"data",id:"id",fields:[{name:"id"},{name:"name",sortType:Ext.data.SortTypes.asUCString}],url:Sonatype.config.servicePath+"/staging/rule_types",sortInfo:{field:"name",direction:"ASC"},autoLoad:true});
this.ruleStore=new Ext.data.SimpleStore({id:0,fields:[{name:"name",sortType:Ext.data.SortTypes.asUCString},{name:"enabled"},{name:"typeId"},{name:"typeName"},{name:"properties"}],sortInfo:{field:"name",direction:"ASC"}});
Sonatype.repoServer.RulesetEditor.superclass.constructor.call(this,{items:[{xtype:"hidden",name:"id"},{xtype:"textfield",fieldLabel:"Name",htmlDecode:true,helpText:"The name of the rule set",itemCls:"required-field",name:"name",width:250,allowBlank:false},{xtype:"textfield",fieldLabel:"Description",htmlDecode:true,helpText:"The description of the rule set",name:"description",width:250},{xtype:"fieldset",title:"Rules",name:"rulesFieldSet",collapsible:false,autoHeight:true,items:[{xtype:"panel",layout:"table",layougConfig:{columns:2},style:"padding-bottom: 10px",items:[{xtype:"combo",fieldLabel:"Rule Type",helpText:"The type of the rule",name:"ruleType",width:530,store:this.ruleTypeDataStore,displayField:"name",valueField:"id",editable:false,emptyText:"Select...",selectOnFocus:true,triggerAction:"all",forceSelection:true,itemCls:"required-field",mode:"local"},{xtype:"button",name:"ruleAdd",text:"Add",handler:this.ruleAddHandler,scope:this,style:"padding-left: 30px"}]},{xtype:"editorgrid",name:"rulesGrid",title:"Applied Rules",autoExpandColumn:"type-column",width:600,height:160,frame:true,store:this.ruleStore,plugins:checkColumn,colModel:new Ext.grid.ColumnModel({defaults:{sortable:true},columns:[checkColumn,{id:"type-column",header:"Type",dataIndex:"typeName"},{width:30,renderer:function(value,meta,record,row,col,store){return'<img src="'+Sonatype.config.extPath+'/resources/images/gray/tabs/tab-close.gif" height="16" width="16" alt="Delete" />'
}}]}),selModel:new Ext.grid.RowSelectionModel({singleSelect:true}),listeners:{cellclick:{fn:function(grid,rowIndex,columnIndex,event){if(columnIndex===2){var record=grid.getStore().getAt(rowIndex);
grid.getStore().remove(record)
}},scope:this}}}]}],buttons:[{name:"rulesetSave",text:"Save",handler:this.saveHandler,scope:this},{name:"rulesetCancel",text:this.isNew?"Cancel":"Reset",handler:this.isNew?this.cancelHandler:this.resetHandler,scope:this}]});
this.on("afterlayout",this.initData,this);
this.initialized=false
};
Ext.extend(Sonatype.repoServer.RulesetEditor,Ext.form.FormPanel,{initData:function(){if(!this.initialized){var i,ruleRec,idField=this.find("name","id")[0],nameField=this.find("name","name")[0],descriptionField=this.find("name","description")[0];
idField.setValue(this.payload.data.id);
nameField.setValue(this.payload.data.name);
this.ruleStore.removeAll();
descriptionField.setValue(this.payload.data.description);
for(i=0;
i<this.payload.data.rules.length;
i=i+1){ruleRec=new Ext.data.Record(this.payload.data.rules[i],this.payload.data.rules[i].name);
this.ruleStore.addSorted(ruleRec)
}if(this.isNew){nameField.setRawValue("")
}this.initialized=true
}},ruleAddHandler:function(){if(!this.validateRuleFields()){return
}var typeId=this.find("name","ruleType")[0].getValue(),typeName=this.ruleTypeDataStore.getById(typeId).data.name,rec=new Ext.data.Record({},typeName);
rec.beginEdit();
rec.set("enabled",true);
rec.set("name",typeName);
rec.set("typeId",typeId);
rec.set("typeName",typeName);
rec.commit();
rec.endEdit();
this.ruleStore.addSorted(rec);
this.resetRuleFields();
this.clearRuleGridInvalid()
},validateRuleFields:function(){var records,i,typeCombo=this.find("name","ruleType")[0];
if(typeCombo.getValue()===""){typeCombo.markInvalid("This field is required");
return false
}records=this.ruleStore.getRange();
for(i=0;
i<records.length;
i=i+1){if(records[i].get("typeId")===typeCombo.getValue()){typeCombo.markInvalid("This Rule is already in the ruleset");
return false
}}return true
},resetRuleFields:function(){this.find("name","ruleType")[0].reset()
},cancelHandler:function(){this.fireEvent("cancel",this)
},resetHandler:function(){this.initialized=false;
this.initData()
},saveHandler:function(){if(!this.validateRuleSet()){return
}var submitUrl=this.isNew?Sonatype.config.servicePath+"/staging/rule_sets":Sonatype.config.servicePath+"/staging/rule_sets/"+this.payload.data.id,submitData={data:{}};
if(this.isNew){submitData.data.id=""
}else{submitData.data.id=this.payload.data.id
}submitData.data.name=this.find("name","name")[0].getValue();
submitData.data.description=this.find("name","description")[0].getValue();
submitData.data.rules=this.getRulesData();
Ext.Ajax.request({scope:this,method:this.isNew?"POST":"PUT",url:submitUrl,jsonData:Ext.util.JSON.encode(submitData),callback:function(options,isSuccess,response){var errMsg,recData;
if(!isSuccess){errMsg=this.isNew?"Unable to create the rule set.":"Unable to update the rule set.";
Sonatype.utils.connectionError(response,errMsg,false,options.options)
}else{recData=Ext.util.JSON.decode(response.responseText).data;
this.updateGrid(recData)
}}})
},getRulesData:function(){var rulesData=[],i;
for(i=0;
i<this.ruleStore.getCount();
i=i+1){rulesData[i]=this.ruleStore.getAt(i).data
}return rulesData
},validateRuleSet:function(){var nameField=this.find("name","name")[0],currentIndex,existingIndex;
if(!nameField.validate()){return false
}if(this.ruleStore.getCount()===0){this.markRuleGridInvalid("At least one rule should be specified!");
return false
}currentIndex=this.payload.store.indexOf(this.payload);
existingIndex=this.payload.store.find("name",new RegExp("^"+nameField.getValue()+"$"));
if(this.isNew){existingIndex=this.payload.store.find("name",new RegExp("^"+nameField.getValue()+"$"),1)
}if(existingIndex!==-1&&existingIndex!==currentIndex){nameField.markInvalid("A rule set with the same name already exists.");
return false
}return true
},clearRuleGridInvalid:function(){var rulesFS=this.find("name","rulesFieldSet")[0],rulesWarning=rulesFS.find("name","rulesWarning")[0];
if(rulesWarning){rulesFS.remove(rulesWarning)
}},markRuleGridInvalid:function(msg){this.clearRuleGridInvalid();
var rulesFS=this.find("name","rulesFieldSet")[0];
rulesFS.insert(1,{xtype:"panel",name:"rulesWarning",layout:"fit",html:'<div style="padding-bottom:10px; padding-top:5px; color:red">'+"WARNING: "+msg+"</div>"});
rulesFS.doLayout()
},updateGrid:function(data){var rec,pos;
this.payload.store.remove(this.payload);
rec=new Ext.data.Record(data,data.resourceURI);
this.payload.store.addSorted(rec);
this.isNew=false;
this.payload.autoCreateNewRecord=false;
pos=this.payload.store.indexOf(rec);
this.grid.gridPanel.getSelectionModel().selectRow(pos)
}});
Sonatype.Events.addListener("rulesetViewInit",function(cardPanel,rec,gridPanel){var sp=Sonatype.lib.Permissions;
if(sp.checkPermission("nexus:stagingrulesets",sp.READ)&&(sp.checkPermission("nexus:stagingrulesets",sp.CREATE)||sp.checkPermission("nexus:stagingrulesets",sp.DELETE)||sp.checkPermission("nexus:stagingrulesets",sp.EDIT))){cardPanel.add(new Sonatype.repoServer.RulesetEditor({name:"configuration",payload:rec,grid:gridPanel}))
}});
Sonatype.repoServer.StagingUploadPanel=function(config){var config=config||{};
var availableModes=[];
if(Sonatype.lib.Permissions.checkPermission("nexus:stagingupload",Sonatype.lib.Permissions.CREATE)){availableModes.push(["pom","Artifact(s) with a POM"]);
availableModes.push(["gav","Artifact(s) with GAV"])
}if(Sonatype.lib.Permissions.checkPermission("nexus:stagingbundleupload",Sonatype.lib.Permissions.CREATE)){availableModes.push(["bundle","Artifact Bundle"])
}var defaultConfig={id:"staging-upload",uploadModeTitle:"Select Staging Upload Mode",uploadModeLabel:"Upload Mode",uploadModeStore:new Ext.data.SimpleStore({fields:["value","display"],data:availableModes}),uploadModeHt:"The mode of staging upload, which depends on how you want to deploy your artifacts.",uploadModeExplanation:"<b>Artifact(s) with a POM:</b> GAV will be defined from a POM file.<br/>"+"<b>Artifact(s) with GAV:</b> GAV needs to be manually defined.<br/>"+'<b>Artifact Bundle:</b> A bundle file produced by <a href="http://maven.apache.org/plugins/maven-repository-plugin/">Maven Repository Plugin</a>, which should contain the POM.',extraItems:{xtype:"textarea",fieldLabel:"Description",helpText:"A detailed description of the staged repository",anchor:Sonatype.view.FIELD_OFFSET,name:"description",allowBlank:false,itemCls:"required-field"}};
Ext.apply(this,config,defaultConfig);
this.payload={id:"invalid-repo-id",data:{repoPolicy:"release"}};
Sonatype.repoServer.StagingUploadPanel.superclass.constructor.call(this,{});
this.on("beforerender",this.beforeRenderHandler,this)
};
Ext.extend(Sonatype.repoServer.StagingUploadPanel,Sonatype.repoServer.ArtifactUploadPanel,{createUploadForm:function(treePanel,fileInput,classifier,extension,lastItem){var pomMode=this.find("name","gavDefinition")[0].getValue()=="pom";
if(this.gavResponse){pomMode=false;
this.form.findField("g").setValue(this.gavResponse.groupId);
this.form.findField("a").setValue(this.gavResponse.artifactId);
this.form.findField("v").setValue(this.gavResponse.version);
this.form.findField("p").setValue(this.gavResponse.packaging)
}var tmpForm=Ext.getBody().createChild({tag:"form",cls:"x-hidden",id:Ext.id(),children:pomMode?[{tag:"input",type:"hidden",name:"hasPom",value:"true"},{tag:"input",type:"hidden",name:"c",value:classifier},{tag:"input",type:"hidden",name:"e",value:extension}]:[{tag:"input",type:"hidden",name:"g",value:this.form.findField("g").getValue()},{tag:"input",type:"hidden",name:"a",value:this.form.findField("a").getValue()},{tag:"input",type:"hidden",name:"v",value:this.form.findField("v").getValue()},{tag:"input",type:"hidden",name:"p",value:this.form.findField("p").getValue()},{tag:"input",type:"hidden",name:"c",value:classifier},{tag:"input",type:"hidden",name:"e",value:extension}]});
if(pomMode){this.pomInput.appendTo(tmpForm)
}if(fileInput){fileInput.appendTo(tmpForm)
}Ext.Ajax.request({url:Sonatype.config.servicePath+"/staging/upload",form:tmpForm,isUpload:true,cbPassThru:{description:this.form.findField("description").getValue(),treePanel:treePanel},callback:function(options,success,response){tmpForm.remove();
if(response.responseText.toLowerCase().indexOf("<error>")==-1){this.gavResponse=Ext.decode(response.responseText);
if(lastItem){this.finishRepository(options.cbPassThru.description);
this.gavResponse=null
}else{this.currentChildNode++;
var treePanel=options.cbPassThru.treePanel;
if(this.currentChildNode<treePanel.root.childNodes.length){this.createUploadForm(treePanel,treePanel.root.childNodes[this.currentChildNode].attributes.payload.fileInput,treePanel.root.childNodes[this.currentChildNode].attributes.payload.classifier,treePanel.root.childNodes[this.currentChildNode].attributes.payload.extension,this.currentChildNode==treePanel.root.childNodes.length-1)
}}}else{var s="Artifact upload failed.<br />";
var r=response.responseText;
var n1=r.toLowerCase().indexOf("<error>")+7;
var n2=r.toLowerCase().indexOf("</error>");
if(n2>n1){s+=r.substring(n1,n2)
}else{s+="Check Nexus logs for more information."
}Sonatype.MessageBox.show({title:"Upload Failed",msg:s,buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.ERROR})
}},scope:this})
},getJsonFromHtmlResponse:function(response){var r=response.responseText;
var n1=r.toLowerCase().indexOf("<pre>")+5;
var n2=r.toLowerCase().indexOf("</pre>");
var json="";
if(n2>n1){json=r.substring(n1,n2)
}else{json=r
}return Ext.util.JSON.decode(json)
},finishRepository:function(description){var profileId=this.gavResponse.profileId;
var repositoryId=this.gavResponse.repositoryId;
Ext.Ajax.request({scope:this,method:"POST",options:{dontForceLogout:true,profileId:profileId,repositoryId:repositoryId},callback:function(options,isSuccess,response){if(!isSuccess){this.dropRepository(options.options.profileId,options.options.repositoryId);
if(response.responseText.indexOf("failures")!==-1){Sonatype.MessageBox.hide();
this.showRulesetEvaluationReport(response.responseText)
}else{Sonatype.utils.connectionError(response,"The server did not close the staging repository, it will be dropped.",false,options.options)
}}else{Sonatype.MessageBox.show({title:"Upload Complete",msg:"Artifact upload finished successfully",buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.INFO});
this.resetFields()
}},jsonData:{data:{stagedRepositoryId:repositoryId,description:description}},url:Sonatype.config.servicePath+"/staging/profiles/"+profileId+"/finish"})
},dropRepository:function(profileId,repositoryId){Ext.Ajax.request({scope:this,method:"POST",options:{dontForceLogout:true},url:Sonatype.config.servicePath+"/staging/profiles/"+profileId+"/drop",jsonData:{data:{stagedRepositoryId:repositoryId}},callback:function(options,isSuccess,response){if(!isSuccess){Sonatype.utils.connectionError(response,"The server did not close the staging repository, and failed to drop it.",false,options.options)
}}})
},gavDefinitionSelectHandler:function(combo,record,index){var gavDefinitionPanel=this.findById("gav-definition-card-panel");
var artifactsUploadFieldset=this.findById("artifacts-upload-fieldset");
gavDefinitionPanel.getLayout().activeItem.items.each(function(item){if(item.xtype!="browsebutton"){item.disable()
}});
this.clearInvalid();
if(record.data.value=="pom"){gavDefinitionPanel.getLayout().setActiveItem(gavDefinitionPanel.items.itemAt(1));
artifactsUploadFieldset.setVisible(true)
}else{if(record.data.value=="gav"){gavDefinitionPanel.getLayout().setActiveItem(gavDefinitionPanel.items.itemAt(2));
artifactsUploadFieldset.setVisible(true)
}else{if(record.data.value=="bundle"){gavDefinitionPanel.getLayout().setActiveItem(gavDefinitionPanel.items.itemAt(3));
artifactsUploadFieldset.setVisible(false)
}else{gavDefinitionPanel.getLayout().setActiveItem(gavDefinitionPanel.items.itemAt(0))
}}}gavDefinitionPanel.getLayout().activeItem.items.each(function(item){if(item.xtype!="browsebutton"){item.enable();
if(item.readOnly){item.getEl().dom.readOnly=true
}}else{item.setClipSize()
}});
this.doLayout()
},beforeRenderHandler:function(formPanel){var bundleUploadEnabled=Sonatype.lib.Permissions.checkPermission("nexus:stagingbundleupload",Sonatype.lib.Permissions.CREATE);
var gavDefinitionPanel=this.findById("gav-definition-card-panel");
gavDefinitionPanel.add({xtype:"fieldset",border:false,checkboxToggle:false,collapsible:false,style:"margin-right:7px;",autoHeight:true,buttonAlign:"center",items:[{hideLabel:true,name:"upload-bundle-button",xtype:"browsebutton",text:"Select Bundle to Upload...",style:"margin-bottom: 5px;",disabled:!bundleUploadEnabled,uploadPanel:this,handler:function(b){b.uploadPanel.bundleInput=b.detachInputFile();
var bundleName=b.uploadPanel.bundleInput.getValue();
b.uploadPanel.updateBundleFileName(b.uploadPanel,bundleName)
}},{xtype:"textfield",fieldLabel:"Bundle Filename",name:"bundle-name-field",anchor:Sonatype.view.FIELD_OFFSET,readOnly:true,allowBlank:false,itemCls:"required-field",disabled:true}],buttons:[{xtype:"button",id:"upload-bundle-button",text:"Upload Bundle",handler:this.uploadBundleHandler,disabled:!bundleUploadEnabled,scope:this},{xtype:"button",id:"reset-bundle-button",text:"Reset",handler:this.resetBundleHandler,disabled:!bundleUploadEnabled,scope:this}]})
},updateBundleFileName:function(uploadPanel,bundleName){var bundleNameField=uploadPanel.find("name","bundle-name-field")[0];
if(bundleName){bundleNameField.setValue(bundleName)
}},resetBundleHandler:function(){var bundleNameField=this.find("name","bundle-name-field")[0];
bundleNameField.reset();
this.bundleInput=null
},uploadBundleHandler:function(){if(!this.bundleInput){Sonatype.MessageBox.show({title:"No Bundle Selected",msg:"You must select a bundle produced by the Maven Repository Plugin.",buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.ERROR})
}else{Sonatype.MessageBox.wait("Uploading ...");
var bundleForm=Ext.getBody().createChild({tag:"form",cls:"x-hidden",id:Ext.id(),children:[]});
this.bundleInput.appendTo(bundleForm);
Ext.Ajax.request({url:Sonatype.config.servicePath+"/staging/bundle_upload",form:bundleForm,isUpload:true,scope:this,callback:function(options,success,response){if(response.responseText.toLowerCase().indexOf("<error>")==-1){if(Ext.isEmpty(response.responseText)){Sonatype.MessageBox.show({title:"Upload Failed",msg:"Artifact bundle upload failed.",buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.ERROR})
}else{var jsonResponse=Ext.decode(response.responseText);
var msg="Artifact Bundle upload finished successfully<br>";
if(jsonResponse.repositoryUris.length==1){msg+="The following staging repository has been created<br><br>"
}else{if(jsonResponse.repositoryUris.length>1){msg+="The following staging repositories have been created<br><br>"
}}for(var i=0;
i<jsonResponse.repositoryUris.length;
i++){msg+='<a href="'+jsonResponse.repositoryUris[i]+'" target="_new">'+jsonResponse.repositoryUris[i]+"</a>"
}Sonatype.MessageBox.show({title:"Upload Complete",msg:msg,buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.INFO})
}}else{var s="Artifact upload failed.<br />";
var r=response.responseText;
var n1=r.toLowerCase().indexOf("<error>")+7;
var n2=r.toLowerCase().indexOf("</error>");
if(n2>n1){if(r.indexOf("failures")!==-1){Sonatype.MessageBox.hide();
this.showRulesetEvaluationReport(Nexus.util.Format.htmlDecode(r.substring(n1,n2)));
s=null
}else{s+=r.substring(n1,n2)
}}else{s+="Check Nexus logs for more information."
}if(s){Sonatype.MessageBox.show({title:"Upload Failed",msg:s,buttons:Sonatype.MessageBox.OK,icon:Sonatype.MessageBox.ERROR})
}}}})
}}});
Nexus.staging.Rules.treat(Sonatype.repoServer.StagingUploadPanel);
Sonatype.Events.addListener("nexusNavigationInit",function(nexusPanel){var enable=Sonatype.lib.Permissions.checkPermission("nexus:stagingupload",Sonatype.lib.Permissions.CREATE)||Sonatype.lib.Permissions.checkPermission("nexus:stagingbundleupload",Sonatype.lib.Permissions.CREATE);
nexusPanel.add({enabled:enable,sectionId:"st-enterprise-staging",title:"Staging Upload",tabId:"staging-upload",tabCode:Sonatype.repoServer.StagingUploadPanel})
});
