#import "nexus-smartproxy-plugin.h"
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0Settings_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0Settings_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0Settings

/**
 * (no documentation provided)
 */
- (BOOL *) enabled
{
  return _enabled;
}

/**
 * (no documentation provided)
 */
- (void) setEnabled: (BOOL *) newEnabled
{
  if (_enabled != NULL) {
    free(_enabled);
  }
  _enabled = newEnabled;
}

/**
 * (no documentation provided)
 */
- (NSString *) advertiseUri
{
  return _advertiseUri;
}

/**
 * (no documentation provided)
 */
- (void) setAdvertiseUri: (NSString *) newAdvertiseUri
{
  [newAdvertiseUri retain];
  [_advertiseUri release];
  _advertiseUri = newAdvertiseUri;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) identity
{
  return _identity;
}

/**
 * (no documentation provided)
 */
- (void) setIdentity: (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) newIdentity
{
  [newIdentity retain];
  [_identity release];
  _identity = newIdentity;
}

/**
 * (no documentation provided)
 */
- (int) port
{
  return _port;
}

/**
 * (no documentation provided)
 */
- (void) setPort: (int) newPort
{
  _port = newPort;
}

/**
 * (no documentation provided)
 */
- (NSString *) host
{
  return _host;
}

/**
 * (no documentation provided)
 */
- (void) setHost: (NSString *) newHost
{
  [newHost retain];
  [_host release];
  _host = newHost;
}

- (void) dealloc
{
  [self setEnabled: NULL];
  [self setAdvertiseUri: nil];
  [self setIdentity: nil];
  [self setHost: nil];
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0Settings */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0Settings (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0Settings (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0Settings (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0Settings from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0Settings defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0Settings *_nEXUS_SMARTPROXY_PLUGINNS0Settings = [[NEXUS_SMARTPROXY_PLUGINNS0Settings alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0Settings initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0Settings = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0Settings autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0Settings;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0Settings according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0Settings to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setEnabled: ((BOOL*) _child_accessor)];
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "advertiseUri", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}advertiseUri of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}advertiseUri of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setAdvertiseUri: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "identity", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}identity of type {}certificate.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0Certificate readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}identity of type {}certificate.");
#endif

    [self setIdentity: __child];
    return YES;
  } //end "if choice"


  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "port", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadIntType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setPort: *((int*) _child_accessor)];
    free(_child_accessor);
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "host", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setHost: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self enabled] != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}enabled."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}enabled...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, [self enabled]);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}enabled...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}enabled."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}enabled."];
    }
  }
  if ([self advertiseUri]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "advertiseUri", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}advertiseUri."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}advertiseUri...");
#endif
    [[self advertiseUri] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}advertiseUri...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}advertiseUri."];
    }
  }
  if ([self identity]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "identity", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}identity."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}identity...");
#endif
    [[self identity] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}identity...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}identity."];
    }
  }
  if (YES) { //always write the primitive element...
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "port", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}port."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}port...");
#endif
    status = xmlTextWriterWriteIntType(writer, &_port);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}port...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}port."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}port."];
    }
  }
  if ([self host]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "host", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}host."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}host...");
#endif
    [[self host] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}host...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}host."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0Settings (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0Settings_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe

/**
 * (no documentation provided)
 */
- (BOOL) subscribe
{
  return _subscribe;
}

/**
 * (no documentation provided)
 */
- (void) setSubscribe: (BOOL) newSubscribe
{
  _subscribe = newSubscribe;
}

/**
 * (no documentation provided)
 */
- (NSString *) repositoryId
{
  return _repositoryId;
}

/**
 * (no documentation provided)
 */
- (void) setRepositoryId: (NSString *) newRepositoryId
{
  [newRepositoryId retain];
  [_repositoryId release];
  _repositoryId = newRepositoryId;
}

/**
 * (no documentation provided)
 */
- (BOOL) publish
{
  return _publish;
}

/**
 * (no documentation provided)
 */
- (void) setPublish: (BOOL) newPublish
{
  _publish = newPublish;
}

/**
 * (no documentation provided)
 */
- (BOOL) preemptiveFetch
{
  return _preemptiveFetch;
}

/**
 * (no documentation provided)
 */
- (void) setPreemptiveFetch: (BOOL) newPreemptiveFetch
{
  _preemptiveFetch = newPreemptiveFetch;
}

- (void) dealloc
{
  [self setRepositoryId: nil];
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe *_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe = [[NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "subscribe", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setSubscribe: *((BOOL*) _child_accessor)];
    free(_child_accessor);
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setRepositoryId: __child];
    return YES;
  } //end "if choice"


  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "publish", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setPublish: *((BOOL*) _child_accessor)];
    free(_child_accessor);
    return YES;
  }

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "preemptiveFetch", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    _child_accessor = xmlTextReaderReadBooleanType(reader);
    if (_child_accessor == NULL) {
      //panic: unable to return the value for some reason.
      [NSException raise: @"XMLReadError"
                   format: @"Error reading element value."];
    }
    [self setPreemptiveFetch: *((BOOL*) _child_accessor)];
    free(_child_accessor);
    return YES;
  }

  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if (YES) { //always write the primitive element...
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "subscribe", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}subscribe."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}subscribe...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, &_subscribe);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}subscribe...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}subscribe."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}subscribe."];
    }
  }
  if ([self repositoryId]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}repositoryId."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}repositoryId...");
#endif
    [[self repositoryId] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}repositoryId...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}repositoryId."];
    }
  }
  if (YES) { //always write the primitive element...
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publish", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}publish."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}publish...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, &_publish);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}publish...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}publish."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}publish."];
    }
  }
  if (YES) { //always write the primitive element...
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "preemptiveFetch", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}preemptiveFetch."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}preemptiveFetch...");
#endif
    status = xmlTextWriterWriteBooleanType(writer, &_preemptiveFetch);
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}preemptiveFetch...");
#endif
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing child element {}preemptiveFetch."];
    }

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}preemptiveFetch."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribe_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse

/**
 * (no documentation provided)
 */
- (NSString *) description
{
  return _description;
}

/**
 * (no documentation provided)
 */
- (void) setDescription: (NSString *) newDescription
{
  [newDescription retain];
  [_description release];
  _description = newDescription;
}

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) certificate
{
  return _certificate;
}

/**
 * (no documentation provided)
 */
- (void) setCertificate: (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) newCertificate
{
  [newCertificate retain];
  [_certificate release];
  _certificate = newCertificate;
}

/**
 * (no documentation provided)
 */
- (NSString *) identifier
{
  return _identifier;
}

/**
 * (no documentation provided)
 */
- (void) setIdentifier: (NSString *) newIdentifier
{
  [newIdentifier retain];
  [_identifier release];
  _identifier = newIdentifier;
}

- (void) dealloc
{
  [self setDescription: nil];
  [self setCertificate: nil];
  [self setIdentifier: nil];
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse *_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse = [[NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setDescription: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "certificate", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}certificate of type {}certificate.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0Certificate readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}certificate of type {}certificate.");
#endif

    [self setCertificate: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setIdentifier: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self description]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}description."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}description...");
#endif
    [[self description] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}description...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}description."];
    }
  }
  if ([self certificate]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "certificate", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}certificate."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}certificate...");
#endif
    [[self certificate] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}certificate...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}certificate."];
    }
  }
  if ([self identifier]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}id."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}id...");
#endif
    [[self identifier] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}id...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}id."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0NexusResponse_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0NexusResponse_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0NexusResponse

- (void) dealloc
{
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0NexusResponse */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0NexusResponse (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0NexusResponse (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0NexusResponse (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0NexusResponse from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0NexusResponse defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0NexusResponse *_nEXUS_SMARTPROXY_PLUGINNS0NexusResponse = [[NEXUS_SMARTPROXY_PLUGINNS0NexusResponse alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0NexusResponse initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0NexusResponse = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0NexusResponse autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0NexusResponse;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0NexusResponse according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0NexusResponse to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0NexusResponse (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0NexusResponse_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest

/**
 * (no documentation provided)
 */
- (NSString *) identifier
{
  return _identifier;
}

/**
 * (no documentation provided)
 */
- (void) setIdentifier: (NSString *) newIdentifier
{
  [newIdentifier retain];
  [_identifier release];
  _identifier = newIdentifier;
}

/**
 * (no documentation provided)
 */
- (NSString *) certificate
{
  return _certificate;
}

/**
 * (no documentation provided)
 */
- (void) setCertificate: (NSString *) newCertificate
{
  [newCertificate retain];
  [_certificate release];
  _certificate = newCertificate;
}

/**
 * (no documentation provided)
 */
- (NSString *) description
{
  return _description;
}

/**
 * (no documentation provided)
 */
- (void) setDescription: (NSString *) newDescription
{
  [newDescription retain];
  [_description release];
  _description = newDescription;
}

- (void) dealloc
{
  [self setIdentifier: nil];
  [self setCertificate: nil];
  [self setDescription: nil];
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest *_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest = [[NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setIdentifier: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "certificate", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}certificate of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}certificate of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setCertificate: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setDescription: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self identifier]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}id."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}id...");
#endif
    [[self identifier] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}id...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}id."];
    }
  }
  if ([self certificate]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "certificate", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}certificate."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}certificate...");
#endif
    [[self certificate] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}certificate...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}certificate."];
    }
  }
  if ([self description]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}description."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}description...");
#endif
    [[self description] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}description...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}description."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0Certificate_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0Certificate_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0Certificate

/**
 * (no documentation provided)
 */
- (NSString *) fingerprint
{
  return _fingerprint;
}

/**
 * (no documentation provided)
 */
- (void) setFingerprint: (NSString *) newFingerprint
{
  [newFingerprint retain];
  [_fingerprint release];
  _fingerprint = newFingerprint;
}

/**
 * (no documentation provided)
 */
- (NSString *) detail
{
  return _detail;
}

/**
 * (no documentation provided)
 */
- (void) setDetail: (NSString *) newDetail
{
  [newDetail retain];
  [_detail release];
  _detail = newDetail;
}

/**
 * (no documentation provided)
 */
- (NSString *) pem
{
  return _pem;
}

/**
 * (no documentation provided)
 */
- (void) setPem: (NSString *) newPem
{
  [newPem retain];
  [_pem release];
  _pem = newPem;
}

- (void) dealloc
{
  [self setFingerprint: nil];
  [self setDetail: nil];
  [self setPem: nil];
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0Certificate */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0Certificate (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0Certificate (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0Certificate (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0Certificate from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0Certificate defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0Certificate *_nEXUS_SMARTPROXY_PLUGINNS0Certificate = [[NEXUS_SMARTPROXY_PLUGINNS0Certificate alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0Certificate initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0Certificate = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0Certificate autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0Certificate;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0Certificate according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0Certificate to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "fingerprint", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}fingerprint of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}fingerprint of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setFingerprint: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "detail", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}detail of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}detail of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setDetail: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "pem", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}pem of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}pem of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setPem: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self fingerprint]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "fingerprint", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}fingerprint."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}fingerprint...");
#endif
    [[self fingerprint] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}fingerprint...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}fingerprint."];
    }
  }
  if ([self detail]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "detail", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}detail."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}detail...");
#endif
    [[self detail] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}detail...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}detail."];
    }
  }
  if ([self pem]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "pem", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}pem."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}pem...");
#endif
    [[self pem] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}pem...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}pem."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0Certificate (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0Certificate_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest *) data
{
  return _data;
}

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest *) newData
{
  [newData retain];
  [_data release];
  _data = newData;
}

- (void) dealloc
{
  [self setData: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope *) [NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope = [[NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope from an XML reader. The element to be read is
 * "settings-request".
 *
 * @param reader The XML reader.
 * @return The NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope *_settingsRequestEnvelope = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element settings-request."];
    }
  }

  if (xmlStrcmp(BAD_CAST "settings-request", xmlTextReaderConstLocalName(reader)) == 0
      && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {}settings-request.");
#endif
    _settingsRequestEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope *)[NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {}settings-request.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope. Expected element settings-request. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope. Expected element settings-request. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _settingsRequestEnvelope;
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope to XML under element name "settings-request".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "settings-request", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {}settings-request. XML writer status: %i\n", rc];
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {}settingsRequestEnvelope for root element {}settings-request...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {}settingsRequestEnvelope for root element {}settings-request...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {}settings-request. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}data of type {}settings-request.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}data of type {}settings-request.");
#endif

    [self setData: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self data]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}data."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}data...");
#endif
    [[self data] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}data...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}data."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequestEnvelope_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse *) data
{
  return _data;
}

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse *) newData
{
  [newData retain];
  [_data release];
  _data = newData;
}

- (void) dealloc
{
  [self setData: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope *) [NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope = [[NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope from an XML reader. The element to be read is
 * "trusted-key-response".
 *
 * @param reader The XML reader.
 * @return The NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope *_trustedKeyResponseEnvelope = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element trusted-key-response."];
    }
  }

  if (xmlStrcmp(BAD_CAST "trusted-key-response", xmlTextReaderConstLocalName(reader)) == 0
      && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {}trusted-key-response.");
#endif
    _trustedKeyResponseEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope *)[NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {}trusted-key-response.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope. Expected element trusted-key-response. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope. Expected element trusted-key-response. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _trustedKeyResponseEnvelope;
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope to XML under element name "trusted-key-response".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-key-response", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {}trusted-key-response. XML writer status: %i\n", rc];
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {}trustedKeyResponseEnvelope for root element {}trusted-key-response...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {}trustedKeyResponseEnvelope for root element {}trusted-key-response...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {}trusted-key-response. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}data of type {}trusted-key.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}data of type {}trusted-key.");
#endif

    [self setData: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self data]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}data."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}data...");
#endif
    [[self data] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}data...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}data."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponseEnvelope_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope

/**
 * (no documentation provided)
 */
- (NSArray *) data
{
  return _data;
}

/**
 * (no documentation provided)
 */
- (void) setData: (NSArray *) newData
{
  [newData retain];
  [_data release];
  _data = newData;
}

- (void) dealloc
{
  [self setData: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope *) [NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope = [[NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope from an XML reader. The element to be read is
 * "trusted-keys-response".
 *
 * @param reader The XML reader.
 * @return The NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope *_trustedKeysResponseEnvelope = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element trusted-keys-response."];
    }
  }

  if (xmlStrcmp(BAD_CAST "trusted-keys-response", xmlTextReaderConstLocalName(reader)) == 0
      && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {}trusted-keys-response.");
#endif
    _trustedKeysResponseEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope *)[NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {}trusted-keys-response.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope. Expected element trusted-keys-response. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope. Expected element trusted-keys-response. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _trustedKeysResponseEnvelope;
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope to XML under element name "trusted-keys-response".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-keys-response", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {}trusted-keys-response. XML writer status: %i\n", rc];
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {}trustedKeysResponseEnvelope for root element {}trusted-keys-response...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {}trustedKeysResponseEnvelope for root element {}trusted-keys-response...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {}trusted-keys-response. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
      NSLog(@"Unwrapping wrapper element {}data...");
#endif
      //start wrapper element "{}data"
      depth = xmlTextReaderDepth(reader);
      status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      while (xmlTextReaderDepth(reader) > depth) {
        if (status < 1) {
          //panic: XML read error.
          [NSException raise: @"XMLReadError"
                       format: @"Failure to advance to next wrapped child element."];
        }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "trusted-key", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}trusted-key of type {}trusted-key.");
#endif

    __child = [NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyResponse readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}trusted-key of type {}trusted-key.");
#endif

    if ([self data]) {
      [self setData: [[self data] arrayByAddingObject: __child]];
    }
    else {
      [self setData: [NSArray arrayWithObject: __child]];
    }
    continue; //continue "while in wrapper element" loop
  } //end "if choice"

        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
#if DEBUG_ENUNCIATE > 1
        NSLog(@"successfully unwrapped wrapper element {}data...");
#endif
      } // end "while in wrapper element" loop

      if (status < 1) {
        //panic: XML read error.
        [NSException raise: @"XMLReadError"
                     format: @"Failure to advance to end wrapper element."];
      }
      else {
        //end wrapper element "{}data"
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
    } //end "if empty element" clause
    else {
      __child = [NSArray array];
      [self setData: (NSArray*) __child];
    }

    return YES;
  } // end "if wrapper element" clause

  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self data]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start wrapper element {}data."];
    }
    __enumerator = [[self data] objectEnumerator];

    while ( (__item = [__enumerator nextObject]) ) {
      status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-key", NULL);
      if (status < 0) {
        [NSException raise: @"XMLWriteError"
                     format: @"Error writing start child element {}trusted-key."];
      }

#if DEBUG_ENUNCIATE > 1
      NSLog(@"writing element {}trusted-key...");
#endif
      [__item writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
      NSLog(@"successfully wrote element {}trusted-key...");
#endif

      status = xmlTextWriterEndElement(writer);
      if (status < 0) {
        [NSException raise: @"XMLWriteError"
                     format: @"Error writing end child element {}trusted-key."];
      }
    } //end item iterator.

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end wrapper element {}data."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeysResponseEnvelope_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest *) data
{
  return _data;
}

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest *) newData
{
  [newData retain];
  [_data release];
  _data = newData;
}

- (void) dealloc
{
  [self setData: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope *) [NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope = [[NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope from an XML reader. The element to be read is
 * "trusted-key-request".
 *
 * @param reader The XML reader.
 * @return The NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope *_trustedKeyRequestEnvelope = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element trusted-key-request."];
    }
  }

  if (xmlStrcmp(BAD_CAST "trusted-key-request", xmlTextReaderConstLocalName(reader)) == 0
      && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {}trusted-key-request.");
#endif
    _trustedKeyRequestEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope *)[NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {}trusted-key-request.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope. Expected element trusted-key-request. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope. Expected element trusted-key-request. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _trustedKeyRequestEnvelope;
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope to XML under element name "trusted-key-request".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-key-request", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {}trusted-key-request. XML writer status: %i\n", rc];
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {}trustedKeyRequestEnvelope for root element {}trusted-key-request...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {}trustedKeyRequestEnvelope for root element {}trusted-key-request...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {}trusted-key-request. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}data of type {}trusted-key.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}data of type {}trusted-key.");
#endif

    [self setData: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self data]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}data."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}data...");
#endif
    [[self data] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}data...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}data."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequestEnvelope_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse *) data
{
  return _data;
}

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse *) newData
{
  [newData retain];
  [_data release];
  _data = newData;
}

- (void) dealloc
{
  [self setData: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope *) [NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope = [[NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope from an XML reader. The element to be read is
 * "settings-response".
 *
 * @param reader The XML reader.
 * @return The NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope *_settingsResponseEnvelope = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element settings-response."];
    }
  }

  if (xmlStrcmp(BAD_CAST "settings-response", xmlTextReaderConstLocalName(reader)) == 0
      && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {}settings-response.");
#endif
    _settingsResponseEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope *)[NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {}settings-response.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope. Expected element settings-response. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope. Expected element settings-response. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _settingsResponseEnvelope;
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope to XML under element name "settings-response".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "settings-response", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {}settings-response. XML writer status: %i\n", rc];
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {}settingsResponseEnvelope for root element {}settings-response...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {}settingsResponseEnvelope for root element {}settings-response...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {}settings-response. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}data of type {}settings-response.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}data of type {}settings-response.");
#endif

    [self setData: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self data]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}data."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}data...");
#endif
    [[self data] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}data...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}data."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponseEnvelope_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse

/**
 * (no documentation provided)
 */
- (NSString *) status
{
  return _status;
}

/**
 * (no documentation provided)
 */
- (void) setStatus: (NSString *) newStatus
{
  [newStatus retain];
  [_status release];
  _status = newStatus;
}

- (void) dealloc
{
  [self setStatus: nil];
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse *_nEXUS_SMARTPROXY_PLUGINNS0SettingsResponse = [[NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0SettingsResponse initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0SettingsResponse = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0SettingsResponse autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0SettingsResponse;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "status", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}status of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}status of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setStatus: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self status]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "status", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}status."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}status...");
#endif
    [[self status] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}status...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}status."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsResponse_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest

/**
 * (no documentation provided)
 */
- (NSArray *) trustedKeys
{
  return _trustedKeys;
}

/**
 * (no documentation provided)
 */
- (void) setTrustedKeys: (NSArray *) newTrustedKeys
{
  [newTrustedKeys retain];
  [_trustedKeys release];
  _trustedKeys = newTrustedKeys;
}

- (void) dealloc
{
  [self setTrustedKeys: nil];
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest *_nEXUS_SMARTPROXY_PLUGINNS0SettingsRequest = [[NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0SettingsRequest initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0SettingsRequest = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0SettingsRequest autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0SettingsRequest;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "trusted-keys", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

    if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
      NSLog(@"Unwrapping wrapper element {}trusted-keys...");
#endif
      //start wrapper element "{}trusted-keys"
      depth = xmlTextReaderDepth(reader);
      status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      while (xmlTextReaderDepth(reader) > depth) {
        if (status < 1) {
          //panic: XML read error.
          [NSException raise: @"XMLReadError"
                       format: @"Failure to advance to next wrapped child element."];
        }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "trusted-key", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}trusted-key of type {}trusted-key.");
#endif

    __child = [NEXUS_SMARTPROXY_PLUGINNS0TrustedKeyRequest readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}trusted-key of type {}trusted-key.");
#endif

    if ([self trustedKeys]) {
      [self setTrustedKeys: [[self trustedKeys] arrayByAddingObject: __child]];
    }
    else {
      [self setTrustedKeys: [NSArray arrayWithObject: __child]];
    }
    continue; //continue "while in wrapper element" loop
  } //end "if choice"

        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
#if DEBUG_ENUNCIATE > 1
        NSLog(@"successfully unwrapped wrapper element {}trusted-keys...");
#endif
      } // end "while in wrapper element" loop

      if (status < 1) {
        //panic: XML read error.
        [NSException raise: @"XMLReadError"
                     format: @"Failure to advance to end wrapper element."];
      }
      else {
        //end wrapper element "{}trusted-keys"
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
    } //end "if empty element" clause
    else {
      __child = [NSArray array];
      [self setTrustedKeys: (NSArray*) __child];
    }

    return YES;
  } // end "if wrapper element" clause

  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self trustedKeys]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-keys", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start wrapper element {}trusted-keys."];
    }
    __enumerator = [[self trustedKeys] objectEnumerator];

    while ( (__item = [__enumerator nextObject]) ) {
      status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-key", NULL);
      if (status < 0) {
        [NSException raise: @"XMLWriteError"
                     format: @"Error writing start child element {}trusted-key."];
      }

#if DEBUG_ENUNCIATE > 1
      NSLog(@"writing element {}trusted-key...");
#endif
      [__item writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
      NSLog(@"successfully wrote element {}trusted-key...");
#endif

      status = xmlTextWriterEndElement(writer);
      if (status < 0) {
        [NSException raise: @"XMLWriteError"
                     format: @"Error writing end child element {}trusted-key."];
      }
    } //end item iterator.

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end wrapper element {}trusted-keys."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0SettingsRequest_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) certificate
{
  return _certificate;
}

/**
 * (no documentation provided)
 */
- (void) setCertificate: (NEXUS_SMARTPROXY_PLUGINNS0Certificate *) newCertificate
{
  [newCertificate retain];
  [_certificate release];
  _certificate = newCertificate;
}

/**
 * (no documentation provided)
 */
- (NSString *) subscriptionStatus
{
  return _subscriptionStatus;
}

/**
 * (no documentation provided)
 */
- (void) setSubscriptionStatus: (NSString *) newSubscriptionStatus
{
  [newSubscriptionStatus retain];
  [_subscriptionStatus release];
  _subscriptionStatus = newSubscriptionStatus;
}

/**
 * (no documentation provided)
 */
- (NSString *) publishStatus
{
  return _publishStatus;
}

/**
 * (no documentation provided)
 */
- (void) setPublishStatus: (NSString *) newPublishStatus
{
  [newPublishStatus retain];
  [_publishStatus release];
  _publishStatus = newPublishStatus;
}

- (void) dealloc
{
  [self setCertificate: nil];
  [self setSubscriptionStatus: nil];
  [self setPublishStatus: nil];
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse *_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse = [[NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "certificate", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}certificate of type {}certificate.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0Certificate readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}certificate of type {}certificate.");
#endif

    [self setCertificate: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "subscriptionStatus", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}subscriptionStatus of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}subscriptionStatus of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setSubscriptionStatus: __child];
    return YES;
  } //end "if choice"

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "publishStatus", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}publishStatus of type {http://www.w3.org/2001/XMLSchema}string.");
#endif
    __child = [NSString readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}publishStatus of type {http://www.w3.org/2001/XMLSchema}string.");
#endif

    [self setPublishStatus: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self certificate]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "certificate", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}certificate."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}certificate...");
#endif
    [[self certificate] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}certificate...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}certificate."];
    }
  }
  if ([self subscriptionStatus]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "subscriptionStatus", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}subscriptionStatus."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}subscriptionStatus...");
#endif
    [[self subscriptionStatus] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}subscriptionStatus...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}subscriptionStatus."];
    }
  }
  if ([self publishStatus]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publishStatus", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}publishStatus."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}publishStatus...");
#endif
    [[self publishStatus] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}publishStatus...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}publishStatus."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest

- (void) dealloc
{
  [super dealloc];
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest (JAXB) <JAXBReading, JAXBWriting, JAXBType>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest *_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest = [[NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse *) data
{
  return _data;
}

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse *) newData
{
  [newData retain];
  [_data release];
  _data = newData;
}

- (void) dealloc
{
  [self setData: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope *) [NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope = [[NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope from an XML reader. The element to be read is
 * "publish-subscribe-response".
 *
 * @param reader The XML reader.
 * @return The NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element publish-subscribe-response."];
    }
  }

  if (xmlStrcmp(BAD_CAST "publish-subscribe-response", xmlTextReaderConstLocalName(reader)) == 0
      && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {}publish-subscribe-response.");
#endif
    _configurePublishSubscribeResponseEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope *)[NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {}publish-subscribe-response.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope. Expected element publish-subscribe-response. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope. Expected element publish-subscribe-response. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _configurePublishSubscribeResponseEnvelope;
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope to XML under element name "publish-subscribe-response".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publish-subscribe-response", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {}publish-subscribe-response. XML writer status: %i\n", rc];
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {}configurePublishSubscribeResponseEnvelope for root element {}publish-subscribe-response...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {}configurePublishSubscribeResponseEnvelope for root element {}publish-subscribe-response...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {}publish-subscribe-response. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}data of type {}publish-subscribe-response.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeResponse readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}data of type {}publish-subscribe-response.");
#endif

    [self setData: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self data]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}data."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}data...");
#endif
    [[self data] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}data...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}data."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeResponseEnvelope_M */
#ifndef DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope_M
#define DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope_M

/**
 * (no documentation provided)
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope

/**
 * (no documentation provided)
 */
- (NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest *) data
{
  return _data;
}

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest *) newData
{
  [newData retain];
  [_data release];
  _data = newData;
}

- (void) dealloc
{
  [self setData: nil];
  [super dealloc];
}

//documentation inherited.
+ (id<EnunciateXML>) readFromXML: (NSData *) xml
{
  NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope;
  xmlTextReaderPtr reader = xmlReaderForMemory([xml bytes], [xml length], NULL, NULL, 0);
  if (reader == NULL) {
    [NSException raise: @"XMLReadError"
                 format: @"Error instantiating an XML reader."];
    return nil;
  }

  _nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope *) [NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope readXMLElement: reader];
  xmlFreeTextReader(reader); //free the reader
  return _nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope;
}

//documentation inherited.
- (NSData *) writeToXML
{
  xmlBufferPtr buf;
  xmlTextWriterPtr writer;
  int rc;
  NSData *data;

  buf = xmlBufferCreate();
  if (buf == NULL) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML buffer."];
    return nil;
  }

  writer = xmlNewTextWriterMemory(buf, 0);
  if (writer == NULL) {
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error creating an XML writer."];
    return nil;
  }

  rc = xmlTextWriterStartDocument(writer, NULL, "utf-8", NULL);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML start document."];
    return nil;
  }

  NS_DURING
  {
    [self writeXMLElement: writer];
  }
  NS_HANDLER
  {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [localException raise];
  }
  NS_ENDHANDLER

  rc = xmlTextWriterEndDocument(writer);
  if (rc < 0) {
    xmlFreeTextWriter(writer);
    xmlBufferFree(buf);
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing XML end document."];
    return nil;
  }

  xmlFreeTextWriter(writer);
  data = [NSData dataWithBytes: buf->content length: buf->use];
  xmlBufferFree(buf);
  return data;
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope */

/**
 * Internal, private interface for JAXB reading and writing.
 */
@interface NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope (JAXB) <JAXBReading, JAXBWriting, JAXBType, JAXBElement>

@end /*interface NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope (JAXB)*/

/**
 * Internal, private implementation for JAXB reading and writing.
 */
@implementation NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope (JAXB)

/**
 * Read an instance of NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope from an XML reader.
 *
 * @param reader The reader.
 * @return An instance of NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope defined by the XML reader.
 */
+ (id<JAXBType>) readXMLType: (xmlTextReaderPtr) reader
{
  NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope *_nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope = [[NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope alloc] init];
  NS_DURING
  {
    [_nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope initWithReader: reader];
  }
  NS_HANDLER
  {
    _nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope = nil;
    [localException raise];
  }
  NS_ENDHANDLER

  [_nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope autorelease];
  return _nEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope;
}

/**
 * Initialize this instance of NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope according to
 * the XML being read from the reader.
 *
 * @param reader The reader.
 */
- (id) initWithReader: (xmlTextReaderPtr) reader
{
  return [super initWithReader: reader];
}

/**
 * Write the XML for this instance of NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope to the writer.
 * Note that since we're only writing the XML type,
 * No start/end element will be written.
 *
 * @param reader The reader.
 */
- (void) writeXMLType: (xmlTextWriterPtr) writer
{
  [super writeXMLType:writer];
}

/**
 * Reads a NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope from an XML reader. The element to be read is
 * "publish-subscribe-request".
 *
 * @param reader The XML reader.
 * @return The NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope.
 */
+ (id<JAXBElement>) readXMLElement: (xmlTextReaderPtr) reader {
  int status;
  NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope = nil;

  if (xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT) {
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
    if (status < 1) {
      [NSException raise: @"XMLReadError"
                   format: @"Error advancing the reader to start element publish-subscribe-request."];
    }
  }

  if (xmlStrcmp(BAD_CAST "publish-subscribe-request", xmlTextReaderConstLocalName(reader)) == 0
      && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read root element {}publish-subscribe-request.");
#endif
    _configurePublishSubscribeRequestEnvelope = (NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope *)[NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"Successfully read root element {}publish-subscribe-request.");
#endif
  }
  else {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope. Expected element publish-subscribe-request. Current element: {}%s", xmlTextReaderConstLocalName(reader)];
    }
    else {
      [NSException raise: @"XMLReadError"
                   format: @"Unable to read NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope. Expected element publish-subscribe-request. Current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader)];
    }
  }

  return _configurePublishSubscribeRequestEnvelope;
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope to XML under element name "publish-subscribe-request".
 * The namespace declarations for the element will be written.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer
{
  [self writeXMLElement: writer writeNamespaces: YES];
}

/**
 * Writes this NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope to an XML writer.
 *
 * @param writer The writer.
 * @param writeNs Whether to write the namespaces for this element to the xml writer.
 */
- (void) writeXMLElement: (xmlTextWriterPtr) writer writeNamespaces: (BOOL) writeNs
{
  int rc = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publish-subscribe-request", NULL);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing start element {}publish-subscribe-request. XML writer status: %i\n", rc];
  }

#if DEBUG_ENUNCIATE > 1
  NSLog(@"writing type {}configurePublishSubscribeRequestEnvelope for root element {}publish-subscribe-request...");
#endif
  [self writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
  NSLog(@"successfully wrote type {}configurePublishSubscribeRequestEnvelope for root element {}publish-subscribe-request...");
#endif
  rc = xmlTextWriterEndElement(writer);
  if (rc < 0) {
    [NSException raise: @"XMLWriteError"
                 format: @"Error writing end element {}publish-subscribe-request. XML writer status: %i\n", rc];
  }
}

//documentation inherited.
- (BOOL) readJAXBAttribute: (xmlTextReaderPtr) reader
{
  void *_child_accessor;

  if ([super readJAXBAttribute: reader]) {
    return YES;
  }

  return NO;
}

//documentation inherited.
- (BOOL) readJAXBValue: (xmlTextReaderPtr) reader
{
  return [super readJAXBValue: reader];
}

//documentation inherited.
- (BOOL) readJAXBChildElement: (xmlTextReaderPtr) reader
{
  id __child;
  void *_child_accessor;
  int status, depth;

  if ([super readJAXBChildElement: reader]) {
    return YES;
  }
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
    NSLog(@"Attempting to read choice {}data of type {}publish-subscribe-request.");
#endif
    __child = [NEXUS_SMARTPROXY_PLUGINNS0PublishSubscribeRequest readXMLType: reader];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully read choice {}data of type {}publish-subscribe-request.");
#endif

    [self setData: __child];
    return YES;
  } //end "if choice"


  return NO;
}

//documentation inherited.
- (int) readUnknownJAXBChildElement: (xmlTextReaderPtr) reader
{
  return [super readUnknownJAXBChildElement: reader];
}

//documentation inherited.
- (void) readUnknownJAXBAttribute: (xmlTextReaderPtr) reader
{
  [super readUnknownJAXBAttribute: reader];
}

//documentation inherited.
- (void) writeJAXBAttributes: (xmlTextWriterPtr) writer
{
  int status;

  [super writeJAXBAttributes: writer];

}

//documentation inherited.
- (void) writeJAXBValue: (xmlTextWriterPtr) writer
{
  [super writeJAXBValue: writer];
}

/**
 * Method for writing the child elements.
 *
 * @param writer The writer.
 */
- (void) writeJAXBChildElements: (xmlTextWriterPtr) writer
{
  int status;
  id __item;
  NSEnumerator *__enumerator;

  [super writeJAXBChildElements: writer];

  if ([self data]) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing start child element {}data."];
    }

#if DEBUG_ENUNCIATE > 1
    NSLog(@"writing element {}data...");
#endif
    [[self data] writeXMLType: writer];
#if DEBUG_ENUNCIATE > 1
    NSLog(@"successfully wrote element {}data...");
#endif

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
      [NSException raise: @"XMLWriteError"
                   format: @"Error writing end child element {}data."];
    }
  }
}
@end /* implementation NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope (JAXB) */

#endif /* DEF_NEXUS_SMARTPROXY_PLUGINNS0ConfigurePublishSubscribeRequestEnvelope_M */
